// ---------------------------------
// Global variables
#define CURRENT_DUNGEON 958
#define PARTY_GLOBAL_SCORE 1201
#define PARTY_GLOBAL_LEVEL 1202
#define CHARACTERS_IN_PARTY 1203
// ---------------------------------

#define TOWN_STOCK_RANDOMIZER 180
#define TOWN_PRIZES_MULTIPLIER 226
#define TOWN_COORDINATES 227
#define TOWN_NAME 230

#define ENCOUNTER_DEFEAT 0
#define ENCOUNTER_TELEPORT 1
#define ENCOUNTER_VICTORY 2

#define SPELL_UNKNOWN 0
#define SPELL_LEARNED 1
#define SPELL_LEARNABLE 2

#define CLASS_THIEF 0
#define CLASS_MONK 1
#define CLASS_RANGER 2
#define CLASS_FIGHTER 3
#define CLASS_PRIEST 4
#define CLASS_WIZARD 5

#define RACE_HUMAN 0
#define RACE_DWARF 1
#define RACE_ELF 2
#define RACE_HALFLING 3
#define RACE_GNOME 4
#define RACE_PIXIE 5
#define RACE_SPRITE 6
#define RACE_OGRE 7
#define RACE_GNOLL 8
#define RACE_TROLL 9
#define RACE_KOBOLD 10
#define RACE_ORC 11
#define RACE_GOBLIN 12
#define RACE_LIZARDMAN 13
#define RACE_MINOTAUR 14
#define RACE_UNDEAD 15
#define RACE_ELEMENTAL 16

#define CHARACTER_STATUS_DEAD 0
#define CHARACTER_STATUS_OKAY 1
#define CHARACTER_STATUS_SLEEP 2

#define CHARACTER_STRENGTH 1
#define CHARACTER_INTELLIGENCE 2
#define CHARACTER_DEXTERITY 3
#define CHARACTER_CONSTITUTION 4
#define CHARACTER_CHARISMA 5
#define CHARACTER_LUCK 6
#define CHARACTER_ADROITNESS 7
#define CHARACTER_SCORE 8
#define CHARACTER_MAX_CLASS_MAGIC 9
#define CHARACTER_MAX_MAGIC 10
#define CHARACTER_CURRENT_MAGIC 11
#define CHARACTER_MAX_HIT_POINTS 12
#define CHARACTER_CURRENT_HIT_POINTS 13
/* 16 bit value */
#define CHARACTER_GOLD_HI 14
#define CHARACTER_GOLD_LO 15
/* 16 bit value */
#define CHARACTER_AGE_HI 16
#define CHARACTER_AGE_LO 17
#define CHARACTER_STATUS 18

#define CHARACTER_SKILL_WEAPON 19

#define CHARACTER_SKILL_ATTACK 20
#define CHARACTER_SKILL_DEFAULT_ATTACK 21
#define CHARACTER_SKILL_PARRY 22
#define CHARACTER_SKILL_DEFAULT_PARRY 23
#define CHARACTER_SKILL_FIND_ITEM 24
#define CHARACTER_SKILL_DEFAULT_FIND_ITEM 25
#define CHARACTER_SKILL_SPOT_TRAP 26
#define CHARACTER_SKILL_DEFAULT_SPOT_TRAP 27
#define CHARACTER_SKILL_DISARM_TRAP 28
#define CHARACTER_SKILL_DEFAULT_DISARM_TRAP 29
#define CHARACTER_SKILL_LISTEN 30
#define CHARACTER_SKILL_DEFAULT_LISTEN 31
#define CHARACTER_SKILL_TOSS_ROCK 32
#define CHARACTER_SKILL_DEFAULT_TOSS_ROCK 33
#define CHARACTER_SKILL_PICK_LOCK 34
#define CHARACTER_SKILL_DEFAULT_PICK_LOCK 35
#define CHARACTER_SKILL_SWIM 38
#define CHARACTER_SKILL_DEFAULT_SWIM 39

#define CHARACTER_ORIGIN 40
#define CHARACTER_AMULETS 41
#define CHARACTER_WAND_OF_NIKADEMUS 42

#define CHARACTER_AIR_RUNES 43
#define CHARACTER_EARTH_RUNES 44
#define CHARACTER_FIRE_RUNES 45
#define CHARACTER_WATER_RUNES 46
#define CHARACTER_GOD_RUNES 47

#define CHARACTER_ITEM_SHIELD_TYPE 48
#define CHARACTER_ITEM_ARMOR_TYPE 49
#define CHARACTER_ITEM_WEAPON_TYPE 50
/* 24 bit value */
#define CHARACTER_EXP_HI 51
#define CHARACTER_EXP_MID 52
#define CHARACTER_EXP_LO 53

#define CHARACTER_LEVEL 54
#define CHARACTER_TEMP_ARMOR_POINT_VALUE 56
#define CHARACTER_TEMP_WEAPON_POINT_VALUE 57
#define CHARACTER_TEMP_SKILL_ATTACK 58
#define CHARACTER_AVAILABLE 59
#define CHARACTER_USED_MAGIC 60

/* An array of 60 booleans */
#define CHARACTER_SPELL_HEALING_1 61
#define CHARACTER_SPELL_HEALING_2 62
#define CHARACTER_SPELL_HEALING_3 63
#define CHARACTER_SPELL_HEALING_4 64
#define CHARACTER_SPELL_FIREFLASH_1 65
#define CHARACTER_SPELL_FIREFLASH_2 66
#define CHARACTER_SPELL_FIREFLASH_3 67
#define CHARACTER_SPELL_FIREFLASH_4 68
#define CHARACTER_SPELL_QUICKNESS_1 69
#define CHARACTER_SPELL_QUICKNESS_2 70
#define CHARACTER_SPELL_QUICKNESS_3 71
#define CHARACTER_SPELL_QUICKNESS_4 72
#define CHARACTER_SPELL_STRENGTH_1 73
#define CHARACTER_SPELL_STRENGTH_2 74
#define CHARACTER_SPELL_STRENGTH_3 75
#define CHARACTER_SPELL_STRENGTH_4 76
#define CHARACTER_SPELL_PROTECTION_1 77
#define CHARACTER_SPELL_PROTECTION_2 78
#define CHARACTER_SPELL_PROTECTION_3 79
#define CHARACTER_SPELL_PROTECTION_4 80
#define CHARACTER_SPELL_CONFUSION_1 81
#define CHARACTER_SPELL_CONFUSION_2 82
#define CHARACTER_SPELL_CONFUSION_3 83
#define CHARACTER_SPELL_CONFUSION_4 84
#define CHARACTER_SPELL_WEAKNESS_1 85
#define CHARACTER_SPELL_WEAKNESS_2 86
#define CHARACTER_SPELL_WEAKNESS_3 87
#define CHARACTER_SPELL_WEAKNESS_4 88
#define CHARACTER_SPELL_BINDING_1 89
#define CHARACTER_SPELL_BINDING_2 90
#define CHARACTER_SPELL_BINDING_3 91
#define CHARACTER_SPELL_BINDING_4 92
#define CHARACTER_SPELL_MINDBLAST_1 93
#define CHARACTER_SPELL_MINDBLAST_2 94
#define CHARACTER_SPELL_MINDBLAST_3 95
#define CHARACTER_SPELL_MINDBLAST_4 96
#define CHARACTER_SPELL_FLAMEBOLT_1 97
#define CHARACTER_SPELL_FLAMEBOLT_2 98
#define CHARACTER_SPELL_FLAMEBOLT_3 99
#define CHARACTER_SPELL_FLAMEBOLT_4 100             /* 40 */
#define CHARACTER_SPELL_CHARM 101
#define CHARACTER_SPELL_SLEEP 102
#define CHARACTER_SPELL_TELEPORTATION 103
#define CHARACTER_SPELL_RESURRECTION 104
#define CHARACTER_SPELL_NINJA_2 105
#define CHARACTER_SPELL_FEAR 106
#define CHARACTER_SPELL_DISSOLVE 107
#define CHARACTER_SPELL_SUMMONS_ELEMENTAL 108
#define CHARACTER_SPELL_DISPELL_UNDEAD 109
#define CHARACTER_SPELL_NINJA_1 110                 /* 50 */
#define CHARACTER_SPELL_AWAKEN 111

#define CHARACTER_SPELL_MONSTER_EVALUATION 112
#define CHARACTER_SPELL_VISION 113
#define CHARACTER_SPELL_TRANSPORTATION 114
/*Accuracy (#55) and Party Accuracy (#56) increase
  the accuracy of bow fire for one member or the whole
  party. (Not in Phantasie I-II)
*/
#define CHARACTER_SPELL_55 115                      /* What are these slots for ? (Not used) */
#define CHARACTER_SPELL_56 116                      /* Apparently only used in Phantasie III */
#define CHARACTER_SPELL_DIVINE_II 117
#define CHARACTER_SPELL_DIVINE_Ia 118               /* Only works in dungeons */

#define CHARACTER_SPELL_DIVINE_Ib 119               /* can't be learned */
#define CHARACTER_SPELL_DIVINE_Ic 120               /* can't be learned */

/* 20 bytes array */
#define CHARACTER_NAME 131

#define CHARACTER_CLASS 151
#define CHARACTER_ITEM_1 152
#define CHARACTER_ITEM_2 153
#define CHARACTER_ITEM_3 154
#define CHARACTER_ITEM_4 155
#define CHARACTER_ITEM_5 156
#define CHARACTER_ITEM_6 157
#define CHARACTER_ITEM_7 158
#define CHARACTER_ITEM_8 159
#define CHARACTER_ITEM_9 160
#define CHARACTER_RACE 161

#define CHARACTER_WEAPON_POINT_VALUE 162
#define CHARACTER_SHIELD_POINT_VALUE 163
#define CHARACTER_ARMOR_POINT_VALUE 164
#define CHARACTER_CURRENT_TOWN 165
#define CHARACTER_LIFESPAN 166
#define CHARACTER_ALREADY_AGED 167

#define CHARACTER_PICTURE 168

#define CHARACTER_BEAST_RUNES 169
