' -----------------------------------------------------
' Phantasie II
' Demo mode
' -----------------------------------------------------
' Decoded and commented by Franck Charlet
' -----------------------------------------------------

demo:

    goto enter_demo

sub_1:

    H1 = 119
    H2 = 120
    for X = 2050 to 2569
        Y = peek(X)
        if Y > H1 then
            poke X, Y - H2
        end if
    next
    return

sub_5:

    H1 = 139
    H2 = 279
    hcolor = 0
    for Y = 1 to 158
        hplot H1, Y to H2, Y
    next
    return

' -----------------------------------------------------
read_demo_chunk:

    gosub read_demo_sequence
    if S <> 0 then
        goto read_demo_chunk
    end if
    return

' -----------------------------------------------------
enter_demo:
    text
    home
    restore
    vtab 11
    print tab(5) "DURING THE DEMO, YOU CAN EXIT"
    print
    print tab(10) "BY PRESSING RETURN."
    &recall "OUTT2"             ' 0x802 / 2050
    gosub sub_1
    poke 0xC010, 0
    hgr
    rot = 0
    hcolor = 3
    hplot 0, 0 to 279, 0
    hplot 0, 159 to 279, 159
    hplot 137, 0 to 137, 159
    hplot 138, 0 to 138, 159
    scale = 1
    gosub read_demo_chunk
    call 816
    gosub read_demo_chunk
    scale = 2
    gosub read_demo_chunk
    scale = 1
    gosub read_demo_chunk
    scale = 2
    gosub read_demo_chunk
    scale = 1
    gosub read_demo_chunk
    scale = 2
    gosub read_demo_chunk
    scale = 1
    gosub read_demo_chunk
    scale = 2
    gosub read_demo_chunk
    scale = 1
    gosub read_demo_chunk
    scale = 2
    gosub read_demo_chunk
    scale = 1
    gosub read_demo_chunk
    scale = 2
    gosub read_demo_chunk
    scale = 1
    gosub read_demo_chunk
    scale = 2
    gosub read_demo_chunk
    scale = 1
    gosub read_demo_chunk
    scale = 4
    gosub read_demo_chunk
    scale = 1
    gosub read_demo_chunk
    hcolor = 3
    for Y = 0 to 159
        hplot 138, Y to 279, Y
    next
    gosub read_demo_chunk
    hcolor = 3
    hplot 0, 0 to 279, 0
    gosub sub_5

    call 816
    gosub read_demo_chunk
    &recall "OUTT12"            ' 0x802 / 2050
    gosub sub_1
    gosub sub_5
    call 816
    gosub read_demo_chunk
    &recall "OUTT28"            ' 0x802 / 2050
    gosub sub_1
    gosub sub_5
    call 816
    gosub read_demo_chunk
    gosub read_demo_chunk
    goto enter_demo

' -----------------------------------------------------
read_demo_sequence:

    ' Poke keyboard without blocking the program
    if peek(0xC000) = 141 then
        text
        home
        &run "INTRO"
    end if

    ' Read demo command
    read S
    ' End of sub sequence
    if S = 0 then
        return
    end if
    ' Play sound 1
    if S = 999 then
        poke 768, 250
        poke 769, 5
        call 770
        poke 768, 1
        poke 769, 1
        call 770
        poke 768, 1
        poke 769, 1
        call 770
        poke 768, 1
        poke 769, 1
        call 770
        return
    end if
    ' Play sound 2 (metal)
    if S = 998 then
        poke 768, 40
        poke 769, 10
        call 770
        poke 768, 40
        poke 769, 30
        call 770
        poke 768, 30
        poke 769, 50
        call 770
        poke 768, 20
        poke 769, 250
        call 770
        return
    end if
    ' Pause script (60 to 997)
    if S > 59 then
        for PS = 1 to 3 * S
        next
        return
    end if
    ' Display string
    if S < 0 then
        goto display_demo_string
    end if
    ' Display shape (1 to 59)
    read X, Y, C
    if C <> 9 then
        hcolor = C
        draw S at X, Y
        return
    end if
    xdraw S at X, Y
    return

' -----------------------------------------------------
display_demo_string:

    read A$
    poke 34, 20
    home
    ' Invert the value and set the speed of the message display
    speed = -1 * S
    print
    ' Display at the center
    print tab(21 - len(A$) / 2) A$
    speed = 255
    for PS = 1 to 1150
    next
    return

' -----------------------------------------------------
' Demo data
    data -127, "WELCOME TO PHANTASIE II!"
    data  -50, "CREATE A PARTY OF UP TO SIX ADVENTURERS"
    data  -50, "CHOOSE FROM SIX CLASSES AND MANY RACES"
    data  -50, "FOR EXAMPLE..."
    data  -50, "A HALFLING THIEF"
    data   25, 0, 158, 3
    data   20, 0, 158, 3  
    data  -50, "AN ELF WIZARD"
    data   27, 19, 158, 3
    data   20, 19, 158, 3
    data  -50, "A DWARVEN PRIEST"
    data   25, 38, 158, 3
    data   20, 38, 158, 3
    data  -50, "A HUMAN RANGER"
    data   19, 57, 158, 3
    data   20, 57, 158, 3
    data  -50, "A GNOME MONK"
    data   25, 76, 158, 3
    data   20, 76, 158, 3
    data  -50, "EVEN A TROLL FIGHTER!"
    data   26, 95, 158, 3
    data   20, 95, 158, 3
    data  -50, "WANDER THE COUNTRYSIDE OF FERRONRAH"
    data    0

    data   43, 259, 140, 9
    data  300
    data   43, 259, 140, 9
    data   43, 259, 134, 9
    data  300
    data   43, 259, 134, 9
    data   43, 259, 128, 9
    data  300
    data   43, 259, 128, 9
    data   43, 259, 122, 9
    data  300
    data   43, 259, 122, 9
    data   43, 266, 122, 9
    data  300
    data   43, 266, 122, 9
    data   43, 266, 116, 9
    data  300
    data   43, 266, 116, 9
    data   43, 266, 110, 9
    data  300
    data   43, 266, 110, 9
    data   43, 266, 104, 9
    data  300
    data   43, 266, 104, 9
    data   43, 266, 98, 9
    data  300  
    data   43, 266, 98, 9
    data   43, 266, 92, 9
    data  300
    data   43, 266, 92, 9
    data   43, 259, 92, 9
    data  300
    data   43, 259, 92, 9
    data   43, 259, 86, 9
    data  300
    data   43, 259, 86, 9
    data   43, 259, 80, 9
    data  300
    data   43, 259, 80, 9
    data   43, 259, 74, 9
    data  300
    data    0

    data  -50, "ENCOUNTER WANDERING MONSTERS"
    data   15, 1, 125, 1
    data   15, 61, 125, 1
    data  500
    data  -50, "BATTLE WITH SPELLS AND WEAPONS"
    data  500
    data    0

    data   20, 76, 158, 0
    data   22, 76, 158, 3
    data  999
    data  666  
    data   20, 19, 158, 0
    data   21, 19, 158, 3
    data   23, 38, 136, 9
    data  998
    data  300
    data   23, 38, 136, 9
    data    0

    data   24, 0, 125, 9
    data  999
    data  300
    data   24, 0, 125, 9
    data  666
    data   15, 61, 125, 0
    data   16, 61, 125, 1
    data  999
    data    0

    data   20, 57, 158, 0
    data   19, 57, 158, 0
    data  666
    data   20, 0, 158, 0
    data   21, 0, 158, 3
    data    0

    data   59, 20, 125, 9
    data  999
    data  100
    data   59, 20, 125, 9
    data  666
    data    0

    data   20, 38, 158, 0
    data   21, 38, 158, 3
    data    0

    data   59, 80, 125, 9
    data  999
    data  100
    data   59, 80, 125, 9
    data   16, 61, 125, 0 
    data  666
    data   15, 1, 125, 0
    data   16, 1, 125, 1
    data    0

    data  999
    data   21, 0, 158, 0
    data   25, 0, 158, 0
    data  666
    data   21, 19, 158, 0
    data   20, 19, 158, 3
    data   21, 38, 158, 0
    data   20, 38, 158, 3
    data   22, 76, 158, 0
    data   20, 76, 158, 3
    data    0

    data   16, 1, 125, 0
    data   15, 1, 125, 1
    data  700
    data    0

    data   20, 19, 158, 0
    data   21, 19, 158, 3
    data   23, 38, 136, 9
    data  998
    data  300
    data   23, 38, 136, 9
    data    0

    data   24, 1, 125, 9
    data  999
    data  300
    data   24, 1, 125, 9
    data   15, 1, 125, 0
    data  666
    data    0

    data   21, 19, 158, 0
    data   20, 19, 158, 3
    data  700
    data  -50, "TAKE GOLD, WEAPONS, AND MAGIC ITEMS"
    data  -50, "THERE ARE 80 DIFFERENT TYPES OF MONSTERS"
    data  -50, "FOR EXAMPLE..."
    data -255, "OVERLORD"
    data   57, 45, 120, 3
    data  666
    data   57, 45, 120, 0
    data   58, 45, 120, 3
    data 1333
    data   58, 45, 120, 0
    data    0

    data -255, "ZOMBIE"
    data   11, 45, 120, 1
    data  666
    data   11, 45, 120, 0
    data   12, 45, 120, 1
    data 1333
    data   12, 45, 120, 0
    data -255, "IMPLING"
    data   17, 45, 120, 3
    data  666
    data   17, 45, 120, 0
    data   18, 45, 120, 3
    data 1333
    data   18, 45, 120, 0
    data -255, "BEEPING BLOBS"
    data    7, 41, 120, 5
    data  666
    data    7, 41, 120, 0
    data    8, 41, 120, 5
    data 1333
    data    8, 41, 120, 0
    data    0

    data -255, "VIPER MOTH"
    data   53, 45, 120, 3
    data  666
    data   53, 45, 120, 0
    data   54, 45, 120, 3
    data 1333
    data   54, 45, 120, 0
    data    0
    data -255, "DEVIL"
    data   49, 34, 120, 2
    data  666
    data   49, 34, 120, 0
    data   50, 34, 120, 2
    data 1333
    data   50, 34, 120, 0
    data    0

    data  -50, "A TERRIBLE CURSE HAS BEFALLEN FERRONRAH"
    data  -50, "YOU MUST REMOVE THIS EVIL FROM THE LAND"
    data  -50, "YOU WILL TRAVEL FAR"
    data   43, 259, 74, 9
    data   43, 259, 68, 9
    data  300
    data   43, 259, 68, 9
    data   43, 259, 62, 9
    data  300
    data   43, 259, 62, 9
    data   43, 252, 62, 9
    data  300
    data   43, 252, 62, 9
    data   43, 252, 56, 9
    data  300
    data   43, 252, 56, 9
    data   43, 252, 50, 9
    data  300
    data   43, 252, 50, 9
    data   43, 245, 50, 9
    data  300
    data   43, 245, 50, 9
    data   43, 245, 44, 9
    data  300
    data   43, 245, 44, 9
    data   43, 245, 38, 9
    data  300
    data   43, 245, 38, 9
    data   43, 238, 38, 9
    data  300
    data   43, 238, 38, 9
    data   43, 231, 38, 9
    data  300
    data  -50, "SWIM TO ISLANDS"
    data   43, 231, 38, 9
    data   43, 224, 38, 9
    data  450
    data   43, 224, 38, 9
    data   43, 217, 38, 9
    data  450
    data   43, 217, 38, 9
    data   43, 210, 38, 9
    data  200
    data   43, 210, 38, 9
    data   43, 203, 38, 9
    data  200
    data   43, 203, 38, 9
    data   43, 203, 32, 9
    data  200
    data   43, 203, 32, 9
    data   43, 196, 32, 9
    data  200
    data   43, 196, 32, 9
    data   43, 189, 32, 9
    data  450
    data   43, 189, 32, 9
    data   43, 182, 32, 9
    data  450
    data   43, 182, 32, 9
    data   43, 175, 32, 9
    data  200
    data   43, 175, 32, 9
    data   43, 168, 32, 9
    data  200
    data   43, 168, 32, 9
    data   43, 168, 38, 9
    data  200
    data   43, 168, 38, 9
    data   43, 161, 38, 9
    data  200
    data   43, 161, 38, 9
    data   43, 161, 44, 9
    data  200
    data   43, 161, 44, 9
    data   43, 161, 50, 9
    data  200
    data   43, 161, 50, 9
    data   43, 161, 56, 9
    data  200
    data  -50, "VISIT TOWNS"
    data  666
    data   43, 161, 56, 9
    data   43, 154, 56, 9
    data  200
    data   43, 154, 56, 9
    data   43, 147, 56, 9
    data  200
    data   43, 147, 56, 9
    data   43, 147, 62, 9
    data  200
    data   43, 147, 62, 9
    data   43, 147, 68, 9
    data  200
    data   43, 147, 68, 9
    data   43, 147, 74, 9
    data  200
    data   43, 147, 74, 9
    data   43, 140, 74, 9
    data  200
    data   43, 140, 74, 9
    data   43, 140, 80, 9
    data  200
    data  -50, "REST AT THE INNS"
    data  666
    data   43, 140, 80, 9
    data   43, 147, 80, 9
    data  200
    data   43, 147, 80, 9
    data   43, 147, 86, 9
    data  200
    data   43, 147, 86, 9
    data   43, 154, 86, 9
    data  200
    data   43, 154, 86, 9
    data   43, 154, 92, 9
    data  200
    data  -50, "THERE ARE EIGHT SPECIAL PLACES"
    data  -50, "INCLUDING CASTLES, DUNGEONS, CAVES,"
    data  -50, "AND A PALACE"
    data  666
    data  -50, "ENTERING A DUNGEON"
    data    0

    data   31, 200, 4, 0
    data   34, 204, 4, 0
    data   31, 208, 4, 0
    data   31, 200, 8, 0
    data   31, 204, 8, 0
    data   31, 208, 8, 0
    data   30, 204, 4, 9
    data  -50, "A MAP IS CREATED AS YOU EXPLORE"
    data  666
    data   30, 204, 4, 9
    data   30, 204, 8, 9
    data   31, 200, 12, 0
    data   31, 204, 12, 0
    data   31, 208, 12, 0
    data  450
    data   30, 204, 8, 9
    data   30, 200, 8, 9
    data   31, 196, 4, 0
    data   31, 196, 8, 0
    data   31, 196, 12, 0
    data  450
    data   30, 200, 8, 9
    data   30, 200, 12, 9
    data  450
    data   30, 200, 12, 9
    data   30, 196, 12, 9
    data   31, 196, 16, 0
    data  450
    data   30, 196, 12, 9
    data   30, 196, 16, 9
    data   31, 196, 20, 0
    data   31, 200, 20, 0
    data  450
    data   30, 196, 16, 9
    data   30, 196, 20, 9
    data   31, 196, 24, 0
    data  450
    data   30, 196, 20, 9
    data   30, 200, 20, 9
    data   31, 204, 20, 0
    data   31, 208, 20, 0
    data   31, 212, 20, 0
    data   31, 216, 20, 0
    data   31, 204, 24, 0
    data   31, 208, 24, 0
    data   31, 212, 24, 0
    data   31, 216, 24, 0
    data   31, 204, 28, 0
    data   31, 208, 28, 0
    data   31, 212, 28, 0
    data   31, 216, 28, 0
    data  450
    data   30, 200, 20, 9
    data   30, 196, 20, 9
    data  450
    data   30, 196, 20, 9
    data   30, 196, 24, 9
    data   31, 196, 28, 0
    data  450
    data   30, 196, 24, 9
    data   30, 196, 28, 9
    data   31, 196, 32, 0
    data  450
    data   30, 196, 28, 9
    data   30, 196, 32, 9
    data   31, 192, 36, 0
    data   33, 192, 36, 3
    data   31, 196, 36, 0
    data   31, 200, 36, 0
    data  450
    data   30, 196, 32, 9
    data   30, 196, 36, 9
    data   31, 196, 40, 0
    data   31, 200, 40, 0
    data  450
    data  -50, "OPEN DOORS"
    data  666
    data   31, 192, 36, 0
    data   31, 188, 32, 0
    data   31, 188, 36, 0
    data   31, 188, 40, 0
    data  666
    data  -50, "ENCOUNTER CREATURES BOTH GOOD AND EVIL"
    data  -50, "TRICKS, TRAPS, AND MANY SPECIAL EVENTS"
    data  666
    data   30, 196, 36, 9
    data   30, 196, 32, 9
    data  450
    data   30, 196, 32, 9
    data   30, 196, 28, 9
    data  450
    data   30, 196, 28, 9
    data   30, 196, 24, 9
    data  450
    data   30, 196, 24, 9
    data   30, 196, 20, 9
    data  450
    data   30, 196, 20, 9
    data   30, 196, 16, 9
    data  450
    data   30, 196, 16, 9
    data   30, 196, 12, 9
    data  450
    data   30, 196, 12, 9
    data   30, 196, 8, 9
    data  450
    data   30, 196, 8, 9
    data   30, 196, 4, 9
    data  450
    data   30, 196, 4, 9
    data   30, 200, 4, 9
    data  450
    data   30, 200, 4, 9
    data   30, 204, 4, 9
    data  450
    data  -50, "RETURNING TO THE WILDERNESS"
    data  666
    data    0

    data   43, 154, 92, 9
    data  450
    data   43, 154, 92, 9
    data   43, 154, 88, 9
    data  450
    data   43, 154, 88, 9
    data   43, 154, 82, 9
    data  450
    data  -50, "YOU WILL TRAVEL THROUGH FERRONRAH"
    data    0

    data  -50, "YOU MAY FIND THE NETHERWORLD"
    data    0

    data  -50, "THE NETHERWORLD IS VERY PERILOUS"
    data  666
    data    1, 0, 130, 3
    data    1, 40, 130, 3
    data    1, 80, 130, 3
    data  700
    data    1, 0, 130, 0
    data    2, 0, 130, 3
    data  999
    data   20, 19, 158, 0
    data   27, 19, 158, 0
    data  666
    data    1, 40, 130, 0
    data    2, 40, 130, 3
    data  999
    data   20, 38, 158, 0
    data   25, 38, 158, 0
    data  666
    data    1, 80, 130, 0
    data    2, 80, 130, 3
    data  999
    data   20, 95, 158, 0
    data   26, 95, 158, 0
    data  666
    data    2, 80, 130, 0
    data    1, 80, 130, 3
    data  666
    data    1, 80, 130, 0
    data    2, 80, 130, 3
    data  999
    data   20, 76, 158, 0
    data   25, 76, 158, 0
    data 1333
    data    0

    data  -50, "MAY YOUR PARTY HAVE BETTER LUCK!!!"
    data 1444
    data    0
