' -----------------------------------------------------
' Phantasie II
' Wilderness
' -----------------------------------------------------
' Decoded and commented by Franck Charlet
' -----------------------------------------------------

wilderness_sequence:

    goto entry_point

wait_keypress:

    poke 0xC010, 0
    get A$
    return

' -----------------------------------------------------
draw_screen:

    poke 0xC050, 0
    hcolor = 3
    hplot 0, 0 to 279, 0
    hplot 0, 159 to 279, 159
    hplot 137, 0 to 137, 159
    hplot 138, 0 to 138, 159
    gosub draw_party
    hcolor = 0
    H1 = 139
    H2 = 279
    for Y = 1 to 158
        hplot H1, Y to H2, Y
    next
    call 816
    return

draw_party:

    scale = 1
    for PM = 0 to cur_characters
        hcolor = 0
        for TM = 20 to 22
            draw TM at PM * 19, 158
        next
        draw get_character_data(CHARACTER_PICTURE) at PM * 19, 158
        if get_character_data(CHARACTER_STATUS) = 0 then
            goto lbl_29
        end if
        hcolor = 3
        draw get_character_data(CHARACTER_PICTURE) at PM * 19, 158
        if IN%(PM) = 3 then
            draw 21 at PM * 19, 158
            goto lbl_29
        end if
        draw 20 at 19 * PM, 158

lbl_29:

    next
    return

' -----------------------------------------------------
entry_point:

    S$ = "+-------------------------------------+"
    on err goto err_handler
    dim terrain_type(12)
    for X = 0 to 12
        read terrain_type(X)
    next
    data "GRASS", "FOREST", "HILLS", "MOUNTAINS", "BUILDINGS", "DUNGEON", "PATHWAY", "NETHERWORLD", "LAVA", "DESERT", "WATER", "MIST", "ASTRAL PLANE"
    SA = 16385
    J1 = 1
    def fn O(X) = SA + 170 * WG + X
    def fn W(X) = peek(SA + 170 * WG + X)
    def get_character_data(X) = peek(SA + 170 * PM + X)
    def character_data_address(X) = SA + 170 * PM + X
    def fn L(X) = peek(SA + PARTY_GLOBAL_LEVEL)
    def fn D(X) = (2 ^ X * int(MF / 2 ^ X)) <> (2 ^ (X - 1) * int(MF / 2 ^ (X - 1)))
    for X = 0 to 8
        read monsters_items_list(X)
    next
    data "SHIELD", "ARMOR", "WEAPON", "GOOD WEAPON", "MAGIC WEAPON", "POTION", "SCROLL", "TREASURE", "GOOD TREASURE"
    status_list(0) = "DEAD"
    status_list(1) = "OKAY"
    status_list(2) = "SLEEP"
    rot = 0
    DP = 1
    cur_characters = peek(SA + CHARACTERS_IN_PARTY)
    for PM = 0 to 6
        for X = CHARACTER_NAME to (CHARACTER_NAME + 10)
            character_names(PM) = character_names(PM) + chr$(get_character_data(X))
        next
    next

    PA = peek(SA + 1204) * 120
    NS = peek(SA + 1205)
    LA = 2050
    def get_map_cell(Z) = peek(LA + Y * 20 + X)
    ' Load the map we're starting in
    &recall "OUTT" + str$(peek(SA + 1191))
    gosub draw_screen
    goto set_external_x_y_coords

' -----------------------------------------------------
start_encounter_system:

    gosub init_temp_characters_values

lbl_889:

    encounter_monsters_species = 0
    LV = 0
    GL = 0
    MS = 0
    MP = 0
    monsters_all_killed = 0
    DA = 0
    SP = 0

    monsters_row(0) = 0
    monsters_row(1) = 1
    monsters_row(2) = 2

    monsters_number(1) = -1
    monsters_number(2) = -1

    ' I think this is used for the elemental summoning
    PM = 6
    poke character_data_address(CHARACTER_STATUS), CHARACTER_STATUS_OKAY
    YS = 0
    MQ = 0
    QM = 0

lbl_900:

    CA = 0
    EX = 0

    ' file number
    MF = int(MO / 8)
    ' Used as offset inside the file
    EF = MO - 8 * MF

    &read "MN2" + str$(MF)
    ' Read given monster file data
    for H = 0 to EF
        input monsters_name(encounter_monsters_species),
              monsters_armor(encounter_monsters_species),
              monster_damage_booster(encounter_monsters_species),
              TM,
              monsters_exp(encounter_monsters_species),
              monsters_magic_user(encounter_monsters_species),
              monsters_spells(encounter_monsters_species, 0),
              monsters_spells(encounter_monsters_species, 1),
              monsters_spells(encounter_monsters_species, 2),
              DM,
              monsters_max_magic_points(encounter_monsters_species),
              WG,
              ML,
              monsters_scale(encounter_monsters_species),
              monsters_hcolor(encounter_monsters_species),
              PM,
              PL,
              monsters_dexterity(encounter_monsters_species),
              X,
              Y,
              YS%(encounter_monsters_species),
              IA,
              IB,
              accuracy(encounter_monsters_species),
              monsters_pictures(encounter_monsters_species)
    next H
    &end
    ' Branch if -10 -9 -8 etc.
    if PM > -11 then
        goto lbl_920
    end if
    MQ = -10 - PM
    ' I guess we check if we already have defeated that minion
    for PM = 0 to cur_characters
        MF = get_character_data(CHARACTER_COLLECTED_AMULETS)
        QM = QM + fn D(MQ)
    next
    if QM = 0 then
        ' Not defeated yet
        home
        vtab 23
        print "ENCOUNTER WITH ONE OF PLUTO'S MINIONS!"
        for PS = 1 to 7000
        next
        goto lbl_920
    end if

    ' We already defeated it
    ' so just trigger a random encounter
    characters_surprise_state = 1
    monsters_surprise_state = 1
    MO = int(rnd(1) * 36)
    goto start_encounter_system

lbl_920:

    ' Set the number of this type of monster in the batch
    monsters_number(encounter_monsters_species) = int(rnd(1) * Y)
    ' Set some values (i don't know what are these 2 arrays)
    for Y = 0 to monsters_number(encounter_monsters_species)
        monsters_hitpoints(encounter_monsters_species, Y) = (.5 + rnd(1)) * DM + .5
        ' Weaker when surprised ?
        ST%(encounter_monsters_species, Y) = 3 - monsters_surprise_state
        GL = GL + X
    next
    LV = LV + TM

    ' BUG: is the NF value not supposed to be resetted
    '      before generating the batch ?
    NF = NF + PM
    ' Max 3 batches
    ' or The percentage of probablility to have more batches
    ' so if the value is 90 there's 90 percent of chance 
    ' that the monster will be accompagnied.
    if encounter_monsters_species = 2 or (rnd(1) * 100) > PL then
        goto end_monsters_batch_gen
    end if
    ' Next monster type in list
    encounter_monsters_species = encounter_monsters_species + 1

    ' Select path for next monster (with a 50/50 bet)
    MO = WG
    if rnd(1) < .5 then
        MO = ML
    end if
    goto lbl_900

end_monsters_batch_gen:

    LV = LV / (encounter_monsters_species + 1)
    NF = NF / (encounter_monsters_species + 1)
    ' PL is now the amount of characters
    PL = cur_characters
    if characters_surprise_state = 1 then
        goto lbl_1480
    end if

display_characters_combat_summary:

    text
    home
    print "#  NAME     ATTACKS MAGIC HIT PTS STATUS"
    print
    PL = -1
    AP = -1
    for PM = 0 to cur_characters
        vtab PM + 2
        print PM + 1 " " character_names(PM) tab(16) int(get_character_data(CHARACTER_TEMP_SKILL_ATTACK) / 75 + 1) tab(21) get_character_data(CHARACTER_CURRENT_MAGIC) "/" get_character_data(CHARACTER_MAX_MAGIC) tab(27) get_character_data(CHARACTER_CURRENT_HIT_POINTS) "/" get_character_data(CHARACTER_MAX_HIT_POINTS) tab(36) status_list(get_character_data(CHARACTER_STATUS))
        if get_character_data(CHARACTER_STATUS) = CHARACTER_STATUS_DEAD then
            goto lbl_1016
        end if
        PL = PL + 1
        ' Start at index 0
        ' Store the place of the character
        characters_positions(PL) = PM
        AP = AP + 2 - get_character_data(CHARACTER_STATUS)

lbl_1016:

    next
    ' No more characters left
    if PL = -1 then
        goto all_characters_dead
    end if

    hcolor = 0
    vtab 9
    print S$

    DM = 0
    ' Draw the mosnters
    for X = 0 to encounter_monsters_species
        ML = -1
        scale = monsters_scale(X)
        for Y = 0 to monsters_number(X)
            ' Why the fuck are trhey drawn here ?
            ' if the code checks if the monster is dead afterwards ?
            draw monsters_pictures(X) at X%(X, Y), Y%(X)
            draw monsters_pictures(X) + 1 at X%(X, Y), Y%(X)
            ' monster is dead: don't draw it
            if monsters_hitpoints(X, Y) < 1 then
                goto lbl_1046
            end if
            TR = X
            ML = ML + 1
            monsters_hitpoints(X, ML) = monsters_hitpoints(X, Y)
            if ST%(X, Y) > 1 and monsters_surprise_state <> 1 then
                ST%(X, ML) = 3
            end if
            ST%(X, ML) = ST%(X, Y)

lbl_1046:

        next Y
        monsters_number(X) = ML
        DM = DM + ML + 1
    next X
    monsters_surprise_state = 0

    FG = 2
    SG = 2
    TG = 2

    HM = -1
    LM = -1
    for X = 0 to 2
        if monsters_number(X) >= HM then
            TG = SG
            SG = FG
            LM = HM
            FG = X
            HM = monsters_number(X)
            goto lbl_1050
        end if
        if monsters_number(X) >= LM then
            TG = SG
            SG = X
            LM = monsters_number(X)
            goto lbl_1050
        end if
        TG = X

lbl_1050:

    next

    ' Now display the monsters infos
    monsters_row(0) = FG
    monsters_row(1) = SG
    monsters_row(2) = TG
    for Q = 0 to encounter_monsters_species
        X = monsters_row(Q)
        if monsters_number(X) > -1 then
            print " RANK " Q + 1 "  " monsters_number(X) + 1 " " monsters_name(X) "(S)"
        end if
    next
    vtab 13
    print S$
    hcolor = 3
    hplot 0, 0 to 138, 0

    ' No monsters were drawn
    if DM = 0 then
        monsters_all_killed = 1
        goto encounter_victory
    end if
    ' They either ran after a dispell undead or dissolved
    if MP = ENCOUNTER_VICTORY then
        goto encounter_victory
    end if
    if MP = ENCOUNTER_TELEPORT then
        goto do_teleportation
    end if

    if EX / monsters_exp(0) * (1 + rnd(1)) < DM * (2 + rnd(1)) then
        goto display_encounter_main_menu
    end if
    print tab(15) "MONSTERS " chr$(7 - NS) "RUN"
    for PS = 1 to 3 * PA
    next
    if rnd(1) * 100 < 80 - 10 * abs(1 - TR) then
        goto encounter_victory
    end if

    for X = 0 to encounter_monsters_species
        for Y = 0 to monsters_number(X)
            ST%(X, Y) = 2
        next
    next

display_encounter_main_menu:

    poke 34, 15
    vtab 17
    print "PARTY OPTIONS 1)FIGHT 2)ACCEPT SURRENDER  3)GREETINGS  4)BEG FOR MERCY  5)FLEE" ;
    gosub wait_keypress
    J = val(A$)
    print
    print
    on J goto display_encounter_fight_menu,
              encounter_monsters_surrender,
              encounter_greet_monsters,
              encounter_beg_for_mercy,
              encounter_flee
    home
    goto display_encounter_main_menu

encounter_flee:

    if rnd(1) * 100 < 80 - 10 * abs(1 - TR) and (PL - AP) < .3 * (PL + 1) then
        goto do_teleportation
    end if
    for PM = 0 to cur_characters
        IN%(PM) = 4
    next
    goto lbl_1480

' -----------------------------------------------------
encounter_beg_for_mercy:

    if (rnd(1) * 100) < (90 + NF) then
        goto encounter_monsters_accept_gold
    end if

encounter_monsters_dont_respond:

    print "THE MONSTERS DON'T RESPOND"
    for PS = 1 to 1500
    next
    goto display_encounter_fight_menu

encounter_monsters_accept_gold:

    print "THE MONSTERS STOP AND TAKE YOUR GOLD"
    GL = -256 * peek(SA + 1199)
    YS = 1
    goto encounter_victory

' -----------------------------------------------------
encounter_monsters_surrender:

    if rnd(1) * 100 > EX / monsters_exp(0) * 25 + 2 * fn L(0) - 3 * LV then
        goto encounter_monsters_dont_respond
    end if
    print "THE MONSTERS SURRENDER"
    goto encounter_victory

' -----------------------------------------------------
encounter_greet_monsters:

    if (rnd(1) * 100 * (1 - CA)) < (50 - NF) then
        goto encounter_monsters_dont_respond
    end if
    print "THE MONSTERS GREET YOU"
    goto lbl_4240

' -----------------------------------------------------
display_encounter_fight_menu:

    home
    print "INDV. OPTIONS: 1)THRUST 2)ATTACK 3)SLASH4)LUNGE 5)SPELL 6)PARRY  7)TOSS  8)REDO"
    poke 34, 18

action_redo:

    home
    for PM = 0 to cur_characters
        if get_character_data(CHARACTER_STATUS) <> CHARACTER_STATUS_OKAY then
            goto lbl_1450
        end if
        goto lbl_1220

lbl_1215:

        print

lbl_1220:

        print character_names(PM) ;

get_action_keypress:

        get A$
        IN = val(A$)
        on IN goto action_thrust,
                   action_attack,
                   action_slash,
                   action_lunge,
                   action_cast,
                   action_parry,
                   action_toss,
                   action_redo
        goto get_action_keypress

' -----------------------------------------------------
action_lunge:

        if get_character_data(CHARACTER_CLASS) <> CLASS_THIEF and get_character_data(CHARACTER_CLASS) <> CLASS_FIGHTER then
            goto get_action_keypress
        end if
        print " LUNGE"
        IN%(PM) = 11
        goto lbl_1460

' -----------------------------------------------------
action_thrust:

        print " THRUST " ;
        TM = 1
        goto do_action

' -----------------------------------------------------
action_attack:

        if get_character_data(CHARACTER_TEMP_SKILL_ATTACK) < 75 then
            goto action_thrust
        end if
        print " ATTACK " ;
        TM = 2
        goto do_action

' -----------------------------------------------------
action_slash:

        if get_character_data(CHARACTER_TEMP_SKILL_ATTACK) < 150 then
            goto action_attack
        end if
        print " SLASH " ;
        TM = int(get_character_data(CHARACTER_TEMP_SKILL_ATTACK) / 75 + 1)

' -----------------------------------------------------
do_action:

        WG = 1
        if encounter_monsters_species < 1 or monsters_number(TR) = DM - 1 or get_character_data(CHARACTER_CLASS) > CLASS_THIEF then
            print
            goto lbl_1300
        end if
        if TM <> 2 then
            print "AT " ;
        end if
        print "RANK " ;
        get A$
        WG = val(A$)
        if WG > encounter_monsters_species + 1 or WG = 0 then
            goto lbl_1215
        end if
        print WG

lbl_1300:

        IN%(PM) = TM * 10 + WG - 1
        goto lbl_1460

' -----------------------------------------------------
action_cast:

        input " CAST SPELL #" ; WG
        if WG < 1 or WG > 51 then
            goto lbl_1220
        end if
        ' Check if spell has been learned
        if get_character_data(WG + (CHARACTER_SPELL_HEALING_1 - 1)) = 1 then
            goto lbl_1350
        end if
        print " SPELL NOT KNOWN"
        goto lbl_1220

lbl_1350:

        ' Check if character have enough magic points
        if get_character_data(CHARACTER_CURRENT_MAGIC) >= WG - 4 * int((WG - 1) / 4) then
            goto lbl_1370
        end if
        print " NOT ENOUGH MAGIC"
        goto lbl_1220

lbl_1370:

        IN%(PM) = 100 + WG
        if WG > 4 then
            goto lbl_1420
        end if
        print " ON PERSON #" ;
        get A$
        TM = val(A$)
        if TM = 0 or TM > cur_characters + 1 then
            goto lbl_1215
        end if
        print TM ;
        IN%(PM) = 1000 * WG + TM - 1

lbl_1420:

        print
        goto lbl_1460

' -----------------------------------------------------
action_parry:

        print " PARRY"
        if rnd(1) * 100 > get_character_data(CHARACTER_SKILL_PARRY) then
            goto lbl_1450
        end if
        IN%(PM) = 3
        goto lbl_1460

lbl_1450:

        IN%(PM) = 4
        goto lbl_1460

' -----------------------------------------------------
action_toss:

        if encounter_monsters_species = 0 then
            print " TOSS"
            IN%(PM) = -1
            goto lbl_1460
        end if
        print " TOSS AT RANK " ;

lbl_1454:

        get A$
        X = val(A$)
        IN%(PM) = -1 * X
        if X < 1 or X > encounter_monsters_species + 1 then
            goto lbl_1454
        end if
        print X

lbl_1460:

    next PM
    print
    print "REDO (Y/N)" ;
    get A$
    if A$ = "Y" then
        goto display_encounter_fight_menu
    end if

lbl_1480:

    ' Y positions to draw (probably the 3 ranks of monsters)
    Y%(monsters_row(0)) = 135
    monsters_surprise_state = 0
    Y%(monsters_row(1)) = 135 - YS%(monsters_row(0))
    X = Y%(monsters_row(1)) - YS%(monsters_row(1))
    ' Make sure the 3rd rank coordinate don't go below 0
    Y%(monsters_row(2)) = X * (X > 0)

    gosub draw_party

    ' draw the monsters
    for X = 0 to encounter_monsters_species
        scale = monsters_scale(X)
        hcolor = monsters_hcolor(X)
        ' No monster of that species to draw anymore
        if monsters_number(X) = -1 then
            goto lbl_1552
        end if
        for Y = 0 to monsters_number(X)
            X%(X, Y) = monsters_hcolor(X) + Y * 120 / (monsters_number(X) + 1)
            draw monsters_pictures(X) at X%(X, Y), Y%(X)
        next

lbl_1552:

    next
    print
    poke 0xC050, 0
    poke 34, 20
    for SR = 1 to 5 step 2
        for PM = 0 to cur_characters
            scale = 1
            home
            if IN%(PM) > 4 then
                goto lbl_1660
            end if
            if IN%(PM) > -1 then
                goto lbl_1630
            end if
            print character_names(PM) " THROWS A ROCK"
            gosub sub_1760
            WG = monsters_row(-1 * IN%(PM) - 1)
            gosub sub_1691
            if TZ < 5 then
                goto lbl_1628
            end if
            if (rnd(1) * 100) > get_character_data(CHARACTER_SKILL_TOSS_ROCK) then
                goto lbl_1628
            end if
            DM = 12 * rnd(1) - monsters_armor(WG)
            DM = DM * (DM > 0) + get_character_data(CHARACTER_SKILL_WEAPON) * rnd(1)
            SP = 2
            gosub do_monster_damage
            goto lbl_1835

lbl_1628:

            print character_names(PM) " MISSES"
            scale = 1
            hcolor = 3
            xdraw 59 at 70, 20
            D = peek(-16336 - NS) + peek(-16336 - NS)
            for PS = 1 to 250
            next
            xdraw 59 at 70, 20
            gosub lbl_4150
            goto lbl_1835

lbl_1630:

            if get_character_data(CHARACTER_STATUS) <> CHARACTER_STATUS_SLEEP then
                goto lbl_1840
            end if
            if rnd(1) > .16 then
                goto lbl_1840
            end if
            print character_names(PM) " AWAKENS"
            poke character_data_address(CHARACTER_STATUS), CHARACTER_STATUS_OKAY
            for PS = 1 to PA
            next
            goto lbl_1840

lbl_1660:

            if 3 * get_character_data(CHARACTER_LEVEL) + 5 * SR * SR < (rnd(1) * 100) then
                goto lbl_1840
            end if
            if IN%(PM) > 90 then
                goto lbl_1750
            end if
            TM = int(IN%(PM) / 10)
            WG = IN%(PM) - TM * 10
            WG = monsters_row(WG)
            for Y = 1 to TM
                home
                gosub sub_1691
                goto lbl_1694

sub_1691:

                for TZ = 0 to 2
                    MN = int((PM + rnd(1) * 2) / (cur_characters + 2) * (monsters_number(WG) + 1))
                    if monsters_hitpoints(WG, MN) > 0 then
                        TZ = 5
                    end if
                next TZ
                return

lbl_1694:

                if TZ < 5 then
                    goto lbl_1740
                end if
                scale = 1
                hcolor = 0
                draw 20 at PM * 19, 158
                hcolor = 3
                draw 22 at PM * 19, 158
                if (rnd(1) * 100) < get_character_data(CHARACTER_TEMP_SKILL_ATTACK) / TM - monsters_dexterity(WG) or ST%(WG, MN) = 1 then
                    goto lbl_1710
                end if
                print character_names(PM) " MISSES"
                P1 = 1
                P2 = 1
                P3 = 1
                P4 = 3
                D1 = 1
                D2 = 1
                D3 = 1
                D4 = 100
                gosub play_sound
                for PS = 1 to PA
                next
                goto lbl_1740

lbl_1710:
                print character_names(PM) " HITS "
                DM = int(rnd(1) ^ .5 * get_character_data(CHARACTER_TEMP_WEAPON_POINT_VALUE) - monsters_armor(WG) + 3 - IN%(PM) / 6.7)
                if MN < 0 then
                    MN = 0
                end if
                gosub do_monster_damage

lbl_1740:

            next Y
            goto lbl_1835

lbl_1750:

            print character_names(PM) " CASTS A SPELL"
            SQ = IN%(PM)
            gosub sub_1760
            goto lbl_1762

sub_1760:

            hcolor = 0
            draw 20 at PM * 19, 158
            hcolor = 3
            draw 21 at PM * 19, 158
            return

lbl_1762:

            xdraw 23 at PM * 19 + 19, 136
            P1 = 40
            P2 = 40
            P3 = 30
            P4 = 20
            D1 = 10
            D2 = 30
            D3 = 50
            D4 = 250
            gosub play_sound
            xdraw 23 at PM * 19 + 19, 136
            if SQ < 1000 then
                SQ = SQ - 104
                goto lbl_1815
            end if
            TM = int(SQ / 1000)
            WG = SQ - 1000 * TM
            print character_names(WG) " IS HEALED"
            DM = int(rnd(1) * (4 + 6 * TM * TM))
            if fn W(CHARACTER_MAX_HIT_POINTS) - fn W(CHARACTER_CURRENT_HIT_POINTS) < DM then
                DM = fn W(CHARACTER_MAX_HIT_POINTS) - fn W(CHARACTER_CURRENT_HIT_POINTS)
            end if
            poke fn O(CHARACTER_CURRENT_HIT_POINTS), fn W(CHARACTER_CURRENT_HIT_POINTS) + DM
            SQ = TM
            goto lbl_1831

lbl_1815:
        
            if SQ > 25 then
                goto lbl_1830
            end if
            on SQ gosub sub_2010,
                        sub_2020,
                        sub_2030,
                        sub_2040,
                        sub_2080,
                        sub_2090,
                        sub_2100,
                        sub_2110,
                        sub_2130,
                        sub_2140,
                        sub_2150,
                        sub_2160,
                        sub_2180,
                        sub_2190,
                        sub_2200,
                        sub_2210,
                        spell_confusion_1,
                        spell_confusion_2,
                        spell_confusion_3,
                        spell_confusion_4,
                        spell_weakness_1,
                        spell_weakness_2,
                        spell_weakness_3,
                        spell_weakness_4,
                        spell_binding_1
            goto lbl_1831

lbl_1830:

            on SQ - 25 gosub spell_binding_2,
                             spell_binding_3,
                             spell_binding_4,
                             spell_mindblast_1,
                             spell_mindblast_2,
                             spell_mindblast_3,
                             spell_mindblast_4,
                             spell_flamebolt_1,
                             spell_flamebolt_2,
                             spell_flamebolt_3,
                             spell_flamebolt_4,
                             spell_charm,
                             spell_sleep,
                             spell_teleportation,
                             spell_resurrect,
                             spell_ninja_2,
                             spell_fear,
                             spell_dissolve,
                             spell_summon_elemental,
                             spell_dispell_undead,
                             spell_ninja_1,
                             spell_awaken

lbl_1831:

            for PS = 1 to PA
            next
            ' Remove the cost of the spell from the caster
            HP = get_character_data(CHARACTER_CURRENT_MAGIC) - SQ + 4 * int((SQ - 1) / 3.95)
            poke character_data_address(CHARACTER_USED_MAGIC), 1
            poke character_data_address(CHARACTER_CURRENT_MAGIC), HP * (HP > 0)

lbl_1835:

            IN%(PM) = 4

lbl_1840:

            print
            SP = 0
        next PM
        for X = 0 to encounter_monsters_species
            scale = monsters_scale(X)
            for Y = 0 to monsters_number(X)
                home
                if ST%(X, Y) = 3 then
                    goto lbl_1885
                end if
                if ST%(X, Y) <> 1 or rnd(1) > .15 then
                    goto lbl_1950
                end if
                print monsters_name(X) " AWAKENS"
                for PS = 1 to PA
                next
                ST%(X, Y) = 2
                goto lbl_1950

lbl_1885:

                if 3 * LV + 5 * SR * SR < rnd(1) * 100 then
                    goto lbl_1950
                end if
                WG = 0
                if (rnd(1) * 100) < monsters_magic_user(X) * (2 + 2 * monsters_row(X)) / (2 + encounter_monsters_species) then
                    goto monster_cast_spell
                end if
                if (monsters_row(2) = X) and YS%(X) < 40 then
                    goto lbl_1950
                end if

lbl_1892:

                TM = int(accuracy(X) / 82)
                if TM < 1 then
                    TM = 1
                end if
                ML = 1
                gosub draw_active_monster

lbl_1897:

                PM = characters_positions((Y + rnd(1)) / (monsters_number(X) + 1) * (PL + 1))
                if (rnd(1) * 100) < accuracy(X) / TM - get_character_data(CHARACTER_ADROITNESS) or get_character_data(CHARACTER_STATUS) = CHARACTER_STATUS_SLEEP then
                    goto lbl_1920
                end if
                print monsters_name(X) " MISSES"
                P1 = 1
                P2 = 1
                P3 = 1
                P4 = 3
                D1 = 1
                D2 = 1
                D3 = 1
                D4 = 100
                gosub play_sound
                for PS = 1 to PA
                next
                goto lbl_1930

lbl_1920:

                DM = int(rnd(1) ^ .5 * monster_damage_booster(X))
                print monsters_name(X) " HITS"
                DM = DM - get_character_data(CHARACTER_TEMP_ARMOR_POINT_VALUE)
                if IN%(PM) = 3 and DM > 0 then
                    DM = DM - get_character_data(CHARACTER_SHIELD_POINT_VALUE)
                    IN%(PM) = 4
                end if
                gosub do_character_damage
                if WG = 100 then
                    goto lbl_1934
                end if
                if WG = 101 then
                    goto lbl_1937
                end if

lbl_1930:

                ML = ML + 1
                if ML > TM then
                    goto lbl_1950
                end if
                goto lbl_1897

lbl_1934:

                print "A STUNNING BLOW "
                poke character_data_address(CHARACTER_STATUS), CHARACTER_STATUS_SLEEP
                IN%(PM) = 4
                for PS = 1 to PA
                next
                goto lbl_1950
        
lbl_1937:

                print "MAGIC IS DRAINED"
                poke character_data_address(CHARACTER_CURRENT_MAGIC), .5 + get_character_data(CHARACTER_CURRENT_MAGIC) * .6
                for PS = 1 to PA
                next
                goto lbl_1950

' Monster casts a spell
monster_cast_spell:

                WG = monsters_spells(X, int(rnd(1) * 3))
                gosub draw_active_monster
                if WG < 34 then
                    print monsters_name(X) " CASTS A SPELL "
                end if
                on WG gosub sub_3000,
                            sub_3010,
                            sub_3020,
                            sub_3030,
                            sub_3060,
                            sub_3060,
                            sub_3060,
                            sub_3060,
                            sub_3050,
                            sub_3050,
                            sub_3050,
                            sub_3050,
                            sub_3070,
                            sub_3070,
                            sub_3070,
                            sub_3070,
                            sub_3080,
                            sub_3080,
                            sub_3080,
                            sub_3080,
                            sub_3090,
                            sub_3090,
                            sub_3090,
                            sub_3090,
                            sub_3100,
                            sub_3100,
                            sub_3100,
                            sub_3100,
                            sub_3110,
                            sub_3110,
                            sub_3110,
                            sub_3110,
                            sub_3120,

                            sub_3210,           ' Not really spells
                            sub_3220,

                            dragon_breath_1,    ' Dragons breath
                            dragon_breath_2
                if WG > 33 then
                    goto lbl_1892
                end if
                for PS = 1 to PA
                next PS

lbl_1950:

                print
            next Y
        next X
    next SR
    goto display_characters_combat_summary

draw_active_monster:

    ST%(X, Y) = 2
    hcolor = 0
    draw monsters_pictures(X) at X%(X, Y), Y%(X)
    hcolor = monsters_hcolor(X)
    draw monsters_pictures(X) + 1 at X%(X, Y), Y%(X)
    return

sub_2010:

    DM = 9
    goto lbl_2050

sub_2020:

    DM = 28
    goto lbl_2050

sub_2030:

    DM = 58
    goto lbl_2050

sub_2040:

    DM = 100

lbl_2050:

    WG = monsters_row(0)
    SP = 1
    DM = 1 + DM * rnd(1) * get_character_data(CHARACTER_INTELLIGENCE) / 15
    if monsters_number(monsters_row(1)) > -1 then
        WG = monsters_row(1)
    end if
    if monsters_number(monsters_row(2)) > -1 then
        WG = monsters_row(2)
    end if
    for Z = 1 to sqr(DM)
        poke -16299, 0
        X = peek(-16336 - NS)
        poke -16300, 0
    next
    for K = 1 to 5
        MN = rnd(1) * (monsters_number(WG) + 1)
        if monsters_hitpoints(WG, MN) >= 1 then
            K = 5
        end if
    next K
    gosub do_monster_damage
    return

sub_2080:

    DM = 10
    goto lbl_2120

sub_2090:

    DM = 25
    goto lbl_2120

sub_2100:

    DM = 45
    goto lbl_2120

sub_2110:

    DM = 70

lbl_2120:

    TM = 58
    goto lbl_2230

sub_2130:

    DM = 2
    goto lbl_2170

sub_2140:

    DM = 4
    goto lbl_2170

sub_2150:

    DM = 7
    goto lbl_2170

sub_2160:

    DM = 11

lbl_2170:

    TM = 57
    goto lbl_2230

sub_2180:

    DM = 1
    goto lbl_2220

sub_2190:

    DM = 3
    goto lbl_2220

sub_2200:

    DM = 6
    goto lbl_2220

sub_2210:

    DM = 10

lbl_2220:

    TM = 56

lbl_2230:

    IN = DM
    for WG = 0 to cur_characters
        if TM = CHARACTER_TEMP_SKILL_ATTACK then
            DM = IN + fn W(CHARACTER_SKILL_ATTACK)
        end if
        if TM = CHARACTER_TEMP_WEAPON_POINT_VALUE then
            DM = IN + fn W(CHARACTER_SKILL_WEAPON) + fn W(CHARACTER_WEAPON_POINT_VALUE)
        end if
        if TM = CHARACTER_TEMP_ARMOR_POINT_VALUE then
            DM = IN + fn W(CHARACTER_ARMOR_POINT_VALUE)
        end if
        if DM > 255 then
            DM = 255
        end if
        poke fn O(TM), DM
    next
    return

' -----------------------------------------------------
spell_confusion_1:

    DM = .8
    goto do_spell_confusion

spell_confusion_2:

    DM = .6
    goto do_spell_confusion

spell_confusion_3:

    DM = .4
    goto do_spell_confusion

spell_confusion_4:

    DM = .2

do_spell_confusion:

    TM = 1
    goto do_character_spell_cast

' -----------------------------------------------------
spell_weakness_1:

    DM = .8
    goto do_spell_weakness

spell_weakness_2:

    DM = .6
    goto do_spell_weakness

spell_weakness_3:

    DM = .4
    goto do_spell_weakness

spell_weakness_4:

    DM = .2

do_spell_weakness:

    TM = 2
    goto do_character_spell_cast

' -----------------------------------------------------
spell_binding_1:

    DM = .85
    goto do_spell_binding

spell_binding_2:

    DM = .70
    goto do_spell_binding

spell_binding_3:

    DM = .55
    goto do_spell_binding

spell_binding_4:

    DM = .45

do_spell_binding:

    TM = 3
    goto do_character_spell_cast

' -----------------------------------------------------
spell_mindblast_1:

    DM = 5
    goto do_spell_mindblast

' -----------------------------------------------------
spell_mindblast_2:

    DM = 11
    goto do_spell_mindblast

' -----------------------------------------------------
spell_mindblast_3:

    DM = 41
    goto do_spell_mindblast

' -----------------------------------------------------
spell_mindblast_4:

    DM = 81

' -----------------------------------------------------
do_spell_mindblast:

    TM = 4

do_character_spell_cast:

    IN = DM
    for Q = 0 to encounter_monsters_species
        WG = monsters_row(Q)
        ' Resisting to magic ?
        if (get_character_data(CHARACTER_MAX_MAGIC) - monsters_max_magic_points(WG)) * 5 + 50 < (rnd(1) * 100) then
            goto lbl_2540
        end if
        ' BUG: see mn2x_structure.txt note about modifs i made here
        ' Confusion
        if TM = 1 then
            monsters_magic_user(WG) = monsters_magic_user(WG) * DM
            accuracy(WG) = accuracy(WG) * DM
        end if
        ' Weakness
        if TM = 2 then
            monster_damage_booster(WG) = monster_damage_booster(WG) * DM
        end if
        ' Binding
        if TM = 3 then
            monsters_dexterity(WG) = monsters_dexterity(WG) * DM
        end if

lbl_2540:

        if TM < 4 then
            goto lbl_2600
        end if
        ' maybe they don't have any mind ?
        if TM = 4 and (monsters_exp(WG) < 2000) and (int(monsters_exp(WG) / 7) = (monsters_exp(WG) / 7)) then
            goto lbl_2600
        end if
        ' global spell ?
        for MN = 0 to monsters_number(WG)
            DM = rnd(1) * IN
            ' Mindblast
            if TM = 4 then
                goto lbl_2570
            end if
            ' Flamebolt
            if TM = 5 then
                goto lbl_2560
            end if
            ' TM = 6
            if (rnd(1) * 100) < (LV * LV) then
                goto lbl_2590
            end if
            print monsters_name(WG) " IS SLEPT"
            ST%(WG, MN) = sgn(ST%(WG, MN))
            for PS = 1 to PA
            next
            goto lbl_2590

lbl_2560:

            DM = DM - monsters_armor(WG)
            goto lbl_2580

lbl_2570:

            if (get_character_data(CHARACTER_MAX_MAGIC) - monsters_max_magic_points(WG)) * 5 + 50 < rnd(1) * 100 then
                goto lbl_2590
            end if

lbl_2580:

            SP = 1
            gosub do_monster_damage

lbl_2590:

        next MN

lbl_2600:

    next Q
    return

' -----------------------------------------------------
spell_flamebolt_1:

    DM = 7
    goto throw_flamebolt

' -----------------------------------------------------
spell_flamebolt_2:

    DM = 15
    goto throw_flamebolt

' -----------------------------------------------------
spell_flamebolt_3:

    DM = 31
    goto throw_flamebolt

' -----------------------------------------------------
spell_flamebolt_4:

    DM = 66

throw_flamebolt:

    TM = 5
    goto do_character_spell_cast

' -----------------------------------------------------
spell_charm:

    if rnd(1) * get_character_data(CHARACTER_LEVEL) < rnd(1) * LV then
        goto spell_charm_failed
    end if
    print "MONSTERS CHARMED"
    NF = NF + 15
    CA = 0

spell_charm_failed:

    return

' -----------------------------------------------------
spell_dissolve:

    if 110 - 10 * LV < (100 * rnd(1)) then
        return
    end if

do_dissolve:

    print "MONSTERS START DISSOLVING"
    MP = ENCOUNTER_VICTORY
    monsters_all_killed = 1
    EX = EX + monsters_exp(0) * monsters_number(0)
    return

' -----------------------------------------------------
spell_ninja_2:

    poke character_data_address(CHARACTER_TEMP_SKILL_ATTACK), 255
    poke character_data_address(57), 25
    poke character_data_address(CHARACTER_TEMP_ARMOR_POINT_VALUE), 10
    return

' -----------------------------------------------------
spell_ninja_1:

    poke character_data_address(CHARACTER_TEMP_SKILL_ATTACK), 200
    poke character_data_address(57), 20
    poke character_data_address(CHARACTER_TEMP_ARMOR_POINT_VALUE), 8
    return

' -----------------------------------------------------
spell_awaken:

    ' Set any living character to CHARACTER_STATUS_OKAY
    for WG = 0 to cur_characters
        poke fn O(CHARACTER_STATUS), (fn W(CHARACTER_STATUS) > CHARACTER_STATUS_DEAD)
    next WG
    print "PARTY AWAKENS"
    return

' -----------------------------------------------------
spell_teleportation:

    if rnd(1) * 100 < 50 + 3 * get_character_data(CHARACTER_LEVEL) then
        MP = ENCOUNTER_TELEPORT
    end if
    return

' -----------------------------------------------------
spell_fear:

    if rnd(1) * 100 > 50 + 5 * (get_character_data(CHARACTER_LEVEL) - LV) then
        return
    end if
    LV = LV - 6
    return

' -----------------------------------------------------
spell_resurrect:

    for WG = 0 to cur_characters
        if (fn W(CHARACTER_STATUS) <> CHARACTER_STATUS_DEAD) or (fn W(CHARACTER_CONSTITUTION) < 1) then
            goto lbl_2850
        end if
        if rnd(1) * 100 > 50 + 5 * (get_character_data(CHARACTER_LEVEL) - fn W(CHARACTER_LEVEL)) then
            goto lbl_2850
        end if
        print character_names(WG) " IS ALIVE"
        poke fn O(CHARACTER_STATUS), CHARACTER_STATUS_OKAY
        poke fn O(CHARACTER_CURRENT_HIT_POINTS), fn W(CHARACTER_MAX_HIT_POINTS)
        WG = cur_characters

lbl_2850:

    next WG
    return

' -----------------------------------------------------
spell_summon_elemental:

    ' can't summon an elemental if there isn't 5 characters in party
    ' BUG: i wonder if it's not a bug as a party can be less then 5 characters
    '      and an elemental should still be summonable
    '      the manual specify that elemental don't respond to less than 6 persons
    if cur_characters <> 5 then
        return
    end if
    cur_characters = 6
    PL = PL + 1
    ' characters_positions(6) = 6
    characters_positions(PL) = cur_characters
    return

' -----------------------------------------------------
spell_sleep:

    TM = 6
    goto do_character_spell_cast

' -----------------------------------------------------
spell_dispell_undead:

    ' DA makes sure the spell can only be used once / encounter
    if monsters_exp(0) / 7 <> int(monsters_exp(0) / 7) or DA = 1 then
        goto lbl_2950
    end if
    DA = 1
    HP = 5 * (get_character_data(CHARACTER_LEVEL) - LV) - (rnd(1) * 100)
    ' If there's a difference of -5 they dissolve
    if HP > -5 then
        goto do_dissolve
    end if
    ' -45 and they run away
    ' (in each case it's a victory but they're considered killed when
    '  they dissolve)
    if HP > -45 then
        print "MONSTERS RUN"
        MP = ENCOUNTER_VICTORY
    end if

lbl_2950:

    return

sub_3000:

    DM = rnd(1) * 12
    goto lbl_3040

sub_3010:

    DM = rnd(1) * 35
    goto lbl_3040

sub_3020:

    DM = rnd(1) * 70
    goto lbl_3040

sub_3030:

    DM = rnd(1) * 120

lbl_3040:

    PM = characters_positions(int(rnd(1) * (PL + 1)))
    gosub do_character_damage
    return

sub_3050:

    monster_damage_booster(X) = 8 + 2 ^ (WG - 8) * 1.5
    return

sub_3060:

    accuracy(X) = 35 + 30 * 2 ^ (WG - 5)
    return

' Why the FUCK would they reduce their armor strength ?
sub_3070:

    monsters_armor(X) = 4 + 4 * (WG - 12)
    return

sub_3080:

    DM = 1 - .2 * (WG - 16)
    TM = 57
    print "THE PARTY'S ARMOR IS REDUCED"
    goto do_monster_cast_spell

sub_3090:

    DM = 1 - .2 * (WG - 20)
    TM = 58
    print "THE PARTY IS SLOWED"
    goto do_monster_cast_spell

sub_3100:

    DM = 10 * 2 ^ (WG - 25) + 6
    TM = 1
    goto do_monster_cast_spell

sub_3110:

    DM = 8 * 2 ^ (WG - 29) + 4
    TM = 2
    goto do_monster_cast_spell

sub_3120:

    TM = 18

do_monster_cast_spell:

    IN = DM
    for PM = 0 to cur_characters
        DM = rnd(1) * IN
        if TM = 2 then
            goto lbl_3180
        end if
        if (monsters_max_magic_points(X) - get_character_data(CHARACTER_MAX_MAGIC)) * 5 + 50 < rnd(1) * 100 then
            goto lbl_3200
        end if
        if TM = 18 then
            goto lbl_3170
        end if
        if TM = 1 then
            goto lbl_3190
        end if
        poke character_data_address(TM), get_character_data(TM) * DM + .5
        goto lbl_3200

lbl_3170:

        print character_names(PM) " IS SLEPT "
        poke character_data_address(TM), 2 * sgn(get_character_data(TM))
        IN%(PM) = 4
        for PS = 1 to PA
        next PS
        goto lbl_3200

lbl_3180:

        DM = DM - get_character_data(CHARACTER_TEMP_ARMOR_POINT_VALUE)

lbl_3190:

        gosub do_character_damage

lbl_3200:

    next PM
    return

sub_3210:

    WG = 100
    return

sub_3220:

    WG = 101
    return

' -----------------------------------------------------
dragon_breath_1:

    DM = 20
    goto do_monster_breath

dragon_breath_2:

    DM = 36

do_monster_breath:

    print monsters_name(X) " BREATHES"
    TM = 2
    goto do_monster_cast_spell

' -----------------------------------------------------
do_character_damage:

    DM = int(DM - 1) * (DM > 1) + 1
    if get_character_data(CHARACTER_STATUS) = CHARACTER_STATUS_DEAD then
        return
    end if
    P4 = 1
    P1 = 250
    P2 = 1
    P3 = 1
    D4 = 1
    D1 = 5
    D2 = 1
    D3 = 1
    gosub play_sound
    print character_names(PM) " TAKES " int(DM) " DAMAGE "
    if get_character_data(CHARACTER_CURRENT_HIT_POINTS) <= DM then
        goto kill_character
    end if
    poke character_data_address(CHARACTER_CURRENT_HIT_POINTS), get_character_data(CHARACTER_CURRENT_HIT_POINTS) - DM
    goto lbl_4030

kill_character:

    print character_names(PM) " DIES"
    poke character_data_address(CHARACTER_CURRENT_HIT_POINTS), 0
    IN%(PM) = 4
    poke character_data_address(CHARACTER_STATUS), CHARACTER_STATUS_DEAD
    poke character_data_address(CHARACTER_CONSTITUTION), get_character_data(CHARACTER_CONSTITUTION) - sgn(get_character_data(CHARACTER_CONSTITUTION)) - (get_character_data(CHARACTER_CONSTITUTION) > 1) * (get_character_data(CHARACTER_LUCK) < 11)
    for PS = 1 to PA
    next
    P1 = 175
    P2 = 175
    P3 = 175
    P4 = 220
    D1 = 85
    D2 = 85
    D3 = 85
    D4 = 250
    gosub play_sound
    AL = 0
    ' Calc the number of still surviving characters
    for WG = 0 to cur_characters
        AL = AL + fn W(CHARACTER_STATUS)
    next
    if AL = 0 then
        goto all_characters_dead
    end if

lbl_4030:

    for PS = 1 to PA
    next PS
    print
    return

' -----------------------------------------------------
do_monster_damage:

    CA = 1
    if DM < 1 then
        DM = 1
    end if
    if MN < 0 then
        goto lbl_4150
    end if
    if monsters_hitpoints(WG, MN) < 1 then
        goto lbl_4160
    end if
    print monsters_name(WG) " TAKES " int(DM) " DAMAGE "
    P4 = 1
    P1 = 250
    P2 = 1
    P3 = 1
    D4 = 1
    D1 = 5
    D2 = 1
    D3 = 1
    gosub play_sound
    monsters_hitpoints(WG, MN) = monsters_hitpoints(WG, MN) - DM
    if SP = 0 then
        goto lbl_4135
    end if
    D = SP * 35 - 11
    SP = 0
    scale = monsters_scale(WG)
    hcolor = 3
    xdraw D at X%(WG, MN), Y%(WG)
    for PS = 1 to 500
    next
    xdraw D at X%(WG, MN), Y%(WG)

lbl_4135:

    if monsters_hitpoints(WG, MN) > 0 then
        goto lbl_4150
    end if
    print monsters_name(WG) " DIES"
    monsters_hitpoints(WG, MN) = 0
    ST%(WG, MN) = 2
    ' Add to collected experience ?
    EX = EX + monsters_exp(WG)
    hcolor = 0
    scale = monsters_scale(WG)
    ' Why the fuck is it drawn if it's DEAD ?
    draw monsters_pictures(WG) at X%(WG, MN), Y%(WG)
    draw monsters_pictures(WG) + 1 at X%(WG, MN), Y%(WG)

lbl_4150:

    for PS = 1 to PA
    next PS
    print

lbl_4160:

    return

' -----------------------------------------------------
init_temp_characters_values:

    for PM = 0 to cur_characters
        poke character_data_address(CHARACTER_TEMP_ARMOR_POINT_VALUE), get_character_data(CHARACTER_ARMOR_POINT_VALUE)
        poke character_data_address(CHARACTER_TEMP_WEAPON_POINT_VALUE), get_character_data(CHARACTER_SKILL_WEAPON) + get_character_data(CHARACTER_WEAPON_POINT_VALUE)
        poke character_data_address(CHARACTER_TEMP_SKILL_ATTACK), get_character_data(CHARACTER_SKILL_ATTACK)
        WG = get_character_data(CHARACTER_DEXTERITY) * 2 - 5 * get_character_data(CHARACTER_ARMOR_POINT_VALUE) + get_character_data(CHARACTER_SKILL_PARRY) / 4
        ' Make the character to wake up
        poke character_data_address(CHARACTER_STATUS), (get_character_data(CHARACTER_STATUS) > CHARACTER_STATUS_DEAD)
        poke character_data_address(CHARACTER_ADROITNESS), WG * (WG > 0) + get_character_data(CHARACTER_SHIELD_POINT_VALUE) / 3
    next PM
    return

' -----------------------------------------------------
all_characters_dead:

    &run "CEMETARY"

' -----------------------------------------------------
do_teleportation:

    CX = OX
    CY = OY

lbl_4240:

    YS = 1
    GL = 0

encounter_victory:

    for PS = 1 to 2000
    next
    text
    home
    if monsters_all_killed = 1 then
        print "MONSTERS KILLED"
    end if
    PM = 6
    poke character_data_address(CHARACTER_STATUS), CHARACTER_STATUS_DEAD
    gosub draw_party
    cur_characters = peek(SA + CHARACTERS_IN_PARTY)
    gosub init_temp_characters_values
    print "EACH SURVIVOR GETS " int(EX / (PL + 1)) " XP AND " int(GL / (PL + 1)) " GOLD"
    for PS = 1 to 3000
    next
    EX = EX / 10

    GL = GL + peek(SA + 1200) + 256 * peek(SA + 1199)
    EX = EX + peek(SA + 1198) + 256 * peek(SA + 1197)
    X = 65535
    if GL > X then
        GL = X
    end if
    if EX > X then
        EX = X
    end if
    poke(SA + 1199), GL / 256
    poke(SA + 1197), EX / 256
    poke(SA + 1198), EX - 256 * peek(SA + 1197)
    poke(SA + 1200), GL - 256 * peek(SA + 1199)

    if MQ = 0 or monsters_number(0) >= 0 then
        goto defeated_minion
    end if
    print
    print "YOU HAVE KILLED ONE OF PLUTO'S MINIONS"
    print character_names(characters_positions(1)) " TAKES AN AMULET"
    for PS = 1 to 11111
    next
    ' Add an amulet to the inventory
    IT = 140 + MQ
    gosub add_acquired_item
    for PM = 0 to cur_characters
        poke character_data_address(CHARACTER_AMULETS), get_character_data(CHARACTER_AMULETS) + 2 ^ (MQ - 1)
    next

defeated_minion:

    if YS = 1 then
        goto command_prompt
    end if
    if rnd(1) * 100 > LV * 2 + 20 then
        goto command_prompt
    end if
    if IA = 0 and IB = 0 then
        goto command_prompt
    end if
    
    IT = int(IA + 3 - rnd(1) * 5)
    gosub ask_keep_found_item
    IT = int(IB + 3 - rnd(1) * 5)
    gosub ask_keep_found_item
    for PS = 1 to 2000
    next
    goto command_prompt

ask_keep_found_item:

    if IT < 1 or IT > 255 then
        return
    end if
    print
    print "YOU FIND " monsters_items_list((IT - 1) / 20) ". KEEP IT?" ;

lbl_4385:

    gosub wait_keypress
    if A$ = "N" then
        return
    end if
    if A$ <> "Y" then
        goto lbl_4385
    end if

add_acquired_item:

    ' Store in temprorary place for later
    PH = 0
    for X = SA + 1210 to SA + 1269
        if peek(X) = 0 then
            PH = X
        end if
    next
    if PH = 0 then
        return
    end if
    poke PH, IT
    return
    goto command_prompt

' -----------------------------------------------------
set_external_x_y_coords:

    CX = peek(SA + 1192)
    CY = peek(SA + 1193)
    OX = CX
    OY = CY

redisplay_screen:

    gosub display_map_menu

display_map_data:

    for X = CX - J1 to CX + J1
        ' Min/Max X
        if X < 0 or X > 19 then
            goto map_x_boundaries
        end if
        for Y = CY - J1 to CY + J1
            ' Min/Max Y
            if Y < 0 or Y > 25 then
                goto map_y_boundaries
            end if

            ' Uncover the cell
            if get_map_cell(0) > 119 then
                poke LA + Y * 20 + X, get_map_cell(0) - 120
            end if
            WG = int(get_map_cell(0) / 10)
            ' Draw the tile
            hcolor = int(1 + .51 * WG)
            draw 37 + WG at 140 + 7 * X, 2 + 6 * Y

map_y_boundaries:

        next Y

map_x_boundaries:

    next X

    ' Handle the special data where the party is located
    X = CX
    Y = CY
    J1 = 1
    WG = get_map_cell(0)        ' 0xBA 186
    TR = int(WG / 10)           ' 0x12 18
    TY = WG - TR * 10           ' TY = 6 (186 - 180)
    DM = 75 * (TR + 1)          ' 1425
    if TR > 3 then
        DM = 60                 ' 60
    end if
    gosub increase_days_out
    if TY = 6 then
        goto display_tile_message
    end if
    if TY = 7 then
        goto scripted_encounter
    end if
    if TY = 8 then
        goto command_prompt
    end if
    if TR = 7 or TR = 11 then
        goto random_encounter
    end if
    if TR = 5 then
        goto ask_enter_dungeon
    end if
    if TR = 8 then
        goto handle_lava_tile
    end if
    if WG = 40 then
        goto ask_enter_town
    end if
    if WG = 41 then
        goto ask_stay_at_inn
    end if
    if TR = 10 then
        goto party_swimming_sequence
    end if

    ' BUG: normally the amount of encounter should decrease
    '      if the party is located on regular path and not in wilderness
    if rnd(1) < .06 then
        goto random_event
    end if

command_prompt:

    gosub display_map_menu
    poke 34, 23
    poke 0xC050, 0
    home
    print "COMMAND:" ;
    xdraw 43 at 140 + 7 * CX, 2 + 6 * CY
    get A$
    xdraw 43 at 140 + 7 * CX, 2 + 6 * CY
    vtab 1
    poke 34, 0
    if A$ = "3" then
        goto go_north
    end if
    CM = asc(A$)
    if CM < 65 or CM > 90 then
        goto command_prompt
    end if
    on CM - 64 goto command_prompt,
                    command_prompt,
                    ask_character_to_cast_spell,
                    command_prompt,
                    go_east,
                    command_prompt,
                    command_prompt,
                    display_party_health,
                    inspect_party,
                    command_prompt,
                    command_prompt,
                    command_prompt,
                    command_prompt,
                    go_north,
                    command_prompt,
                    command_prompt,
                    command_prompt,
                    command_prompt,
                    go_south,
                    set_time_lag,
                    ask_character_to_use_potion,
                    command_prompt,
                    go_west
    goto command_prompt

go_north:

    DN = 1
    DE = 0
    goto move_on_map

go_south:

    DN = -1
    DE = 0
    goto move_on_map

go_east:

    DN = 0
    DE = 1
    goto move_on_map

go_west:

    DN = 0
    DE = -1

' -----------------------------------------------------
move_on_map:

    X = CX + DE
    Y = CY - DN
    if X < 0 or X > 19 or Y < 0 or Y > 25 then
        goto out_of_map
    end if
    if get_map_cell(0) <> 100 then
        goto lbl_5340
    end if
    home
    vtab 23
    if peek(SA + 1191) > 16 then
        print "THE RIVER STYX"
        for PS = 1 to 2000
        next
        goto command_prompt
    end if
    print "THAT IS OCEAN"
    for PS = 1 to 1000
    next
    goto command_prompt

lbl_5340:

    OX = CX
    OY = CY
    CX = X
    CY = Y
    goto display_map_data

' -----------------------------------------------------
out_of_map:

    BF = peek(SA + 1191) + DE - 4 * DN
    if DN = 0 then
        CX = 19 * (DE < 0)
    end if
    if DE = 0 then
        CY = 25 * (DN > 0)
    end if
    gosub save_map
    &recall "OUTT" + str$(BF)
    poke 1191 + SA, BF
    gosub draw_screen
    goto redisplay_screen

' -----------------------------------------------------
display_map_menu:

    home
    vtab 21
    htab 10
    print "------ " terrain_type(TR + 5 * (TR = 7) * (peek(SA + 1191) = 26)) " ------"
    print "C)AST  H)EALTH  I)NSPECT        W) 3) E)U)SE POTION   T)IME LAG            S)"
    return

search_map_special_place:

    LC = 520

lbl_5960:

    if peek(LA + LC) = CX and peek(LA + LC + 1) = CY then
        return
    end if
    if LC > 620 then
        return
    end if
    LC = LC + 5
    goto lbl_5960

display_tile_message:

    gosub search_map_special_place
    home
    vtab 24
    M1 = peek(LC + 2 + LA)
    LC = 2645 + 40 * M1
    poke 804, LC / 256
    poke 803, LC - peek(804) * 256
    call 800
    get A$
    goto command_prompt

scripted_encounter:

    gosub search_map_special_place
    home
    vtab 24
    MO = peek(LC + 2 + LA)
    goto encounter_start

random_encounter:

    if rnd(1) < .08 then
        MO = int(12 * TY + rnd(1) * 3)
        home
        vtab 24
        goto encounter_start
    end if
    goto command_prompt

party_swimming_sequence:

    text
    home
    print " ---SWIMMING---"
    print
    for PM = 0 to cur_characters
        if get_character_data(CHARACTER_STATUS) = CHARACTER_STATUS_DEAD then
            goto lbl_6180
        end if
        if rnd(1) * 100 < get_character_data(CHARACTER_SKILL_SWIM) then
            goto lbl_6170
        end if
        print character_names(PM) " SINKS"
        DM = int(rnd(1) * 5 + 1)
        gosub do_character_damage
        print
        goto lbl_6180

lbl_6170:

        print character_names(PM) " SWIMS"
        print

lbl_6180:

    next PM
    gosub wait_keypress
    goto command_prompt

random_event:

    home
    vtab 24
    PH = 0
    if rnd(1) < .38 then
        goto lbl_6420
    end if
    MO = 12 * TY + int(2 + rnd(1) * 10)
    if rnd(1) < .25 then
        goto lbl_6220
    end if
    MO = 12 * TY + int(rnd(1) * 2) + 2 * peek(993 + TR + rnd(1) * 4)

lbl_6220:

    if rnd(1) < .36 then
        goto lbl_6380
    end if
    PH = -1
    for PM = 0 to cur_characters
        if rnd(1) * 188 > get_character_data(CHARACTER_SKILL_LISTEN) or get_character_data(CHARACTER_STATUS) = CHARACTER_STATUS_DEAD then
            goto lbl_6250
        end if
        PH = PM

lbl_6250:

    next
    if PH > -1 then
        print character_names(PH) " HEARS MONSTERS"
    end if
    if rnd(1) * 100 < 30 + 8 * TY then
        goto characters_surprised
    end if
    if PH = -1 then
        goto encounter_start
    end if
    print "F)IGHT OR R)UN"

lbl_6285:

    gosub wait_keypress
    if A$ = "F" then
        goto monsters_surprised
    end if
    if A$ <> "R" then
        goto lbl_6285
    end if
    ' Calc the chance of running success
    if rnd(1) < .8 then
        goto command_prompt
    end if
    goto encounter_start

monsters_surprised:

    if rnd(1) < .3 then
        goto encounter_start
    end if
    print "YOU SURPRISED THEM"
    monsters_surprise_state = 1
    characters_surprise_state = 0
    goto start_encounter_system

characters_surprised:

    if PH > -1 then
        goto encounter_start
    end if
    if rnd(1) < .5 then
        goto encounter_start
    end if
    print "MONSTERS SURPRISE YOU"
    characters_surprise_state = 1
    monsters_surprise_state = 0
    goto start_encounter_system

encounter_start:

    print "AN ENCOUNTER"
    characters_surprise_state = 1
    monsters_surprise_state = 1
    goto start_encounter_system

lbl_6380:

    print "YOU SPOT SLEEPING MONSTERS. LEAVE?" ;

lbl_6383:

    gosub wait_keypress
    if A$ = "Y" then
        goto command_prompt
    end if
    if A$ <> "N" then
        goto lbl_6383
    end if
    characters_surprise_state = 1
    monsters_surprise_state = 2
    goto start_encounter_system

lbl_6420:

    MO = int(rnd(1) * 5)
    if MO = 2 or MO = 3 then
        goto lbl_6420
    end if
    MO = MO + TY * 12
    characters_surprise_state = 1
    monsters_surprise_state = 1
    for K = 1 to 15
        PM = int(rnd(1) * (cur_characters + 1))
        if get_character_data(CHARACTER_STATUS) > CHARACTER_STATUS_DEAD then
            K = 15
        end if
    next K
    print "A NIGHT ENCOUNTER"
    if get_character_data(CHARACTER_STATUS) > CHARACTER_STATUS_DEAD then
        print character_names(PM) " IS ON WATCH"
        if rnd(1) * 100 < get_character_data(CHARACTER_SKILL_LISTEN) then
            print "HEARS THE MONSTERS"
            goto start_encounter_system
        end if
    end if
    X = PM
    gosub init_temp_characters_values
    for PM = 0 to cur_characters
        if get_character_data(CHARACTER_STATUS) = CHARACTER_STATUS_OKAY then
            poke character_data_address(CHARACTER_STATUS), CHARACTER_STATUS_SLEEP
        end if
    next PM
    PM = X
    if get_character_data(CHARACTER_STATUS) = CHARACTER_STATUS_SLEEP then
        poke character_data_address(CHARACTER_STATUS), CHARACTER_STATUS_OKAY
    end if
    goto lbl_889

handle_lava_tile:

    if TY = 0 then
        goto command_prompt
    end if
    text
    home
    print "------- LAVA ------"
    for PM = 0 to cur_characters
        if get_character_data(CHARACTER_STATUS) = CHARACTER_STATUS_DEAD then
            goto lbl_6560
        end if
        DM = int(1 + rnd(1) * 10 * TY)
        gosub do_character_damage

lbl_6560:

    next PM
    gosub wait_keypress
    goto command_prompt

' -----------------------------------------------------
ask_character_to_use_potion:

    text
    home
    print "WHO WILL USE POTION" ;
    get A$
    PM = val(A$) - 1
    if PM < 0 or PM > cur_characters then
        goto command_prompt
    end if
    text
    home
    print tab(7) character_names(PM)
    print S$
    J = 0
    for X = CHARACTER_ITEM_1 to CHARACTER_ITEM_9
        Y = get_character_data(X)
        if Y < 101 or Y > 120 then
            goto lbl_6745
        end if
        print X - 151 "    " ;
        J = J + 1
        if Y < 111 then
            print "HEALING POTION " Y - 100
            goto lbl_6745
        end if
        print "MAGIC POTION " Y - 110

lbl_6745:

    next
    if J = 0 then
        print "YOU HAVE NO POTIONS"
        print
        print S$
        for PS = 1 to 3000
        next
        goto command_prompt
    end if
    print
    print S$
    print
    print "USE WHICH POTION " ;
    get A$
    IT = val(A$)
    if IT = 0 then
        goto command_prompt
    end if
    IM = get_character_data(IT + (CHARACTER_ITEM_1 - 1))
    if IM < 101 or IM > 120 then
        goto command_prompt
    end if
    print A$
    print "ON WHOM " ;

lbl_6780:

    get A$
    WG = val(A$) - 1
    if WG < 0 or WG > cur_characters then
        goto lbl_6780
    end if
    poke character_data_address(IT + (CHARACTER_ITEM_1 - 1)), 0
    print A$
    if IM < 111 then
        goto lbl_6830
    end if
    DM = IM * 3 - 330 + fn W(CHARACTER_CURRENT_MAGIC)
    if DM > fn W(CHARACTER_MAX_MAGIC) then
        DM = fn W(CHARACTER_MAX_MAGIC)
    end if

    print character_names(WG) " RECEIVES MAGIC"
    poke fn O(CHARACTER_CURRENT_MAGIC), DM
    goto delay

lbl_6830:

    DM = (IM - 100) ^ 2 + fn W(CHARACTER_CURRENT_HIT_POINTS)
    if DM > fn W(CHARACTER_MAX_HIT_POINTS) then
        DM = fn W(CHARACTER_MAX_HIT_POINTS)
    end if

increase_character_hit_point:

    print character_names(WG) " IS HEALED"
    poke fn O(CHARACTER_CURRENT_HIT_POINTS), DM

delay:

    for PS = 1 to 2000
    next
    goto command_prompt

' -----------------------------------------------------
ask_character_to_cast_spell:

    text
    home
    print "WHO WILL CAST SPELL " ;
    get A$
    PM = val(A$) - 1
    if PM < 0 or PM > cur_characters then
        goto command_prompt
    end if
    print A$
    print
    if get_character_data(CHARACTER_STATUS) = CHARACTER_STATUS_DEAD then
        goto command_prompt
    end if
    input "WHICH SPELL?" ; WS
    if WS < (CHARACTER_SPELL_HEALING_1 - 60) or WS > (CHARACTER_SPELL_60 - 60) then
        goto command_prompt
    end if
    if get_character_data(WS + (CHARACTER_SPELL_HEALING_1 - 1)) <> 1 then
        goto ask_character_to_cast_spell
    end if
    ' Calc cost of spell
    DM = WS - 4 * int((WS - 1) / 3.95)
    ' Check if character have enough magic points
    if get_character_data(CHARACTER_CURRENT_MAGIC) < DM then
        goto ask_character_to_cast_spell
    end if
    ' yes: remove them
    poke character_data_address(CHARACTER_CURRENT_MAGIC), get_character_data(CHARACTER_CURRENT_MAGIC) - DM
    if WS = (CHARACTER_SPELL_RESURRECTION - 60) then
        gosub spell_resurrect
        gosub draw_party
    end if
    if WS < (CHARACTER_SPELL_FIREFLASH_1 - 60) then
        goto cast_healing_spell
    end if
    LeV = 2 * (TY + 1)
    if LeV > 12 then
        LeV = 12
    end if
    if WS = (CHARACTER_SPELL_MONSTER_EVALUATION - 60) then
        print "MONSTERS ARE LEVEL " LeV
    end if
    ' Determine the amount of tiles the party can see around itself
    if WS = (CHARACTER_SPELL_VISION - 60) then
        J1 = int(get_character_data(CHARACTER_LEVEL) / 2 + 2.5)
        print "OKAY"
    end if
    ' That spell only work in in astral plane (OUTT26)
    if WS = (CHARACTER_SPELL_DIVINE_II - 60) and peek(SA + 1191) = 26 then
        goto summon_astral_plane_monster
    end if
    if WS >= (CHARACTER_SPELL_DIVINE_I - 60) then
        print "THAT SPELL WILL NOT WORK IN WILDERNESS"
    end if
    if WS = (CHARACTER_SPELL_DIVINE_II - 60) then
        print "THAT SPELL WILL NOT WORK ON THIS PLANE"
    end if
    goto delay

cast_healing_spell:

    print
    print "ON WHOM " ;

lbl_7015:

    get A$
    WG = val(A$) - 1
    if WG < 0 or WG > cur_characters then
        goto lbl_7015
    end if
    print A$
    DM = int(rnd(1) * (4 + 6 * WS * WS)) + fn W(CHARACTER_CURRENT_HIT_POINTS)
    if DM > fn W(CHARACTER_MAX_HIT_POINTS) then
        DM = fn W(CHARACTER_MAX_HIT_POINTS)
    end if
    goto increase_character_hit_point

' -----------------------------------------------------
ask_enter_town:

    home
    vtab 24
    print "A TOWN. ENTER?" ;
    get A$
    if A$ = "N" then
        goto command_prompt
    end if
    if A$ <> "Y" then
        goto ask_enter_town
    end if
    gosub search_map_special_place
    gosub save_map
    ' Store town index before entering it
    poke SA + 1191, peek(LA + LC + 2)
    &run "TOWN"

' -----------------------------------------------------
ask_enter_dungeon:

    home
    vtab 24
    print "A DUNGEON. ENTER?" ;
    get A$
    if A$ = "N" then
        goto command_prompt
    end if
    if A$ <> "Y" then
        goto ask_enter_dungeon
    end if
    gosub search_map_special_place
    gosub save_map
    ' Store dungeon index before entering it
    for X = 2 to 4
        poke SA + 1189 + X, peek(LA + LC + X)
    next
    goto load_dungeon

' -----------------------------------------------------
ask_stay_at_inn:

    home
    vtab 24
    print "AN INN. STAY?" ;
    get A$
    if A$ = "N" then
        goto command_prompt
    end if
    if A$ <> "Y" then
        goto ask_stay_at_inn
    end if
    text
    home
    if peek(SA + 1199) < 1 then
        print "YOU CAN NOT AFFORD IT"
        goto delay
    end if
    poke(SA + 1199), peek(SA + 1199) - 1
    for PM = 0 to cur_characters
        if get_character_data(CHARACTER_STATUS) = CHARACTER_STATUS_DEAD then
            goto lbl_7310
        end if
        print character_names(PM) " IS RESTING. " ;
        if get_character_data(CHARACTER_USED_MAGIC) = 0 then
            goto lbl_7260
        end if
        poke character_data_address(CHARACTER_USED_MAGIC), 0
        if rnd(1) * 100 > 20 * (get_character_data(CHARACTER_MAX_CLASS_MAGIC) - get_character_data(CHARACTER_MAX_MAGIC)) then
            goto lbl_7260
        end if
        poke character_data_address(CHARACTER_MAX_MAGIC), get_character_data(CHARACTER_MAX_MAGIC) + 1
        print " MAGIC INCREASES." ;

lbl_7260:

        poke character_data_address(CHARACTER_CURRENT_MAGIC), get_character_data(CHARACTER_MAX_MAGIC)
        poke character_data_address(CHARACTER_CURRENT_HIT_POINTS), get_character_data(CHARACTER_MAX_HIT_POINTS)
        print

lbl_7310:

    next PM
    DM = 1000
    gosub increase_days_out
    get A$
    goto command_prompt

' -----------------------------------------------------
inspect_party:

    text
    home
    print "DAYS OUT: " peek(SA + 1194)
    print "EXPERIENCE POINTS EARNED: " 10 * (256 * peek(SA + 1197) + peek(SA + 1198))
    print "GOLD PIECES CARRIED: " 256 * peek(SA + 1199) + peek(SA + 1200)
    print "ITEMS ACQUIRED:"

    for X = 0 to 8
        acquired_items(X) = 0
    next
    for X = SA + 1210 to SA + 1269
        J = int((peek(X) - 1) / 20)
        if J < 0 then
            goto lbl_7420
        end if
        acquired_items(J) = acquired_items(J) + 1

lbl_7420:

    next
    for X = 0 to 8
        if acquired_items(X) = 0 then
            goto lbl_7430
        end if
        print tab(10) monsters_items_list(X) "S: " acquired_items(X)

lbl_7430:

    next
    vtab 23
    get A$
    for PM = 0 to cur_characters
        home
        print "#" PM + 1 " " character_names(PM) "  LEVEL " get_character_data(CHARACTER_LEVEL) "  " status_list(get_character_data(CHARACTER_STATUS))
        print
        print "HIT POINTS " get_character_data(CHARACTER_CURRENT_HIT_POINTS) "/" get_character_data(CHARACTER_MAX_HIT_POINTS) tab(20) "MAGIC " get_character_data(CHARACTER_CURRENT_MAGIC) "/" get_character_data(CHARACTER_MAX_MAGIC)
        print
        print "SKILLS:  ATTACK " get_character_data(CHARACTER_SKILL_ATTACK) tab(25) "SWIM " get_character_data(CHARACTER_SKILL_SWIM)
        print tab(11) "PARRY " get_character_data(CHARACTER_SKILL_PARRY) tab(23) "LISTEN " get_character_data(CHARACTER_SKILL_LISTEN)
        print tab(25) "TOSS " get_character_data(CHARACTER_SKILL_TOSS_ROCK)
        print
        print "SPELLS:" ;
        for X = 1 to 60
            if get_character_data(X + (CHARACTER_SPELL_HEALING_1 - 1)) = 1 then
                print "  " X ;
            end if
        next
        print
        vtab 14
        print "POTIONS:"
        for X = CHARACTER_ITEM_1 to CHARACTER_ITEM_9
            J = get_character_data(X)
            ' [101..110]
            if J > 100 and J < 111 then
                print tab(10) "HEALING " J - 100
            end if
            ' [111..120]
            if J > 110 and J < 121 then
                print tab(10) "MAGIC " J - 110
            end if
        next
        vtab 23
        get A$
    next
    goto command_prompt

' -----------------------------------------------------
increase_days_out:

    DM = DM + peek(SA + 1194) * 256 + peek(SA + 1195)
    if DM > 65535 then
        DM = 65535
    end if
    poke(SA + 1194), DM / 256
    poke(SA + 1195), DM - 256 * peek(SA + 1194)
    return

' -----------------------------------------------------
set_time_lag:

    home
    vtab 22
    print "TIME LAG " ;
    get A$
    X = val(A$)
    print X
    PA = 120 * X
    print
    print "SOUND?" ;
    get A$
    NS = (A$ = "N")
    poke SA + 1204, X
    poke SA + 1205, NS
    goto command_prompt

' -----------------------------------------------------
play_sound:

    if NS = 1 then
        return
    end if
    poke 768, P1
    poke 769, D1
    call 770
    poke 768, P2
    poke 769, D2
    call 770
    poke 768, P3
    poke 769, D3
    call 770
    poke 768, P4
    poke 769, D4
    call 770
    return

' -----------------------------------------------------
load_dungeon:

    &run "DNGLD"

' -----------------------------------------------------
save_map:

    FL = peek(SA + 1191)
    W$ = "OUTT" + str$(FL)
    &del W$
    &store W$, 2050, 756
    return

' -----------------------------------------------------
summon_astral_plane_monster:

    MO = int(rnd(1) * rnd(1) * 72)
    if rnd(1) < .25 then
        ' 25% chance to encounter one of the 2 right monsters
        ' PLUTO'S WYVERN & PLUTO'S SNAKE-DRAGON
        MO = int(74 + 2 * rnd(1))
    end if
    goto encounter_start

' -----------------------------------------------------
display_party_health:

    text
    home
    vtab 4
    print tab(11) "---PARTY HEALTH---"
    vtab 8
    print S$
    print " # NAME" tab(16) "MAGIC  HIT PTS  STATUS"
    print S$
    for PM = 0 to cur_characters
        print " " PM + 1 " " character_names(PM) tab(16) get_character_data(CHARACTER_CURRENT_MAGIC) "/" get_character_data(CHARACTER_MAX_MAGIC) tab(23) get_character_data(CHARACTER_CURRENT_HIT_POINTS) "/" get_character_data(CHARACTER_MAX_HIT_POINTS) tab(32) status_list(get_character_data(CHARACTER_STATUS))
    next
    print S$
    vtab 23
    get A$
    goto command_prompt

' -----------------------------------------------------

err_handler:

    ER = peek(222)
    if ER = 254 then
        resume
    end if

fatal_error:

    text
    home
    print "ERROR #" ER
    goto fatal_error
