/* --------------------------------
   Phantasie II CD32
   Characters sheets
   --------------------------------
   Copyright (C) 2010-2016 Franck Charlet.
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:

       1. Redistributions of source code must retain the above copyright notice,
          this list of conditions and the following disclaimer.
       2. Redistributions in binary form must reproduce the above copyright notice,
          this list of conditions and the following disclaimer in the documentation
          and/or other materials provided with the distribution.

   THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS "AS IS" AND
   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED. IN NO EVENT SHALL FRANCK CHARLET OR CONTRIBUTORS BE LIABLE
   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
   OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
   SUCH DAMAGE.
   -------------------------------- */

#ifndef _CHARACTERS_SHEETS_H_
#define _CHARACTERS_SHEETS_H_

/* --------------------------------
   Variables
   -------------------------------- */
extern BOOL Cancel_Sheet;

/* --------------------------------
   Functions
   -------------------------------- */
void Prepare_Character_Sheet_Context(int Location, int Idx);
void Destroy_Sheet();
void Character_Select_Item();
void Select_Character(void (*Events)(void *, int, ULONG), int Selection_Type);
void Display_Hit_Points(LPCHARACTER Character);
void Display_Magic_Points(LPCHARACTER Character);
void Display_Spells_List(LPCHARACTER Character,
                         void (*Events)(void *, int, ULONG),
                         int Type);

#endif

