/* --------------------------------
   Phantasie II CD32
   Main program
   --------------------------------
   Copyright (C) 2010-2016 Franck Charlet.
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:

       1. Redistributions of source code must retain the above copyright notice,
          this list of conditions and the following disclaimer.
       2. Redistributions in binary form must reproduce the above copyright notice,
          this list of conditions and the following disclaimer in the documentation
          and/or other materials provided with the distribution.

   THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS "AS IS" AND
   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED. IN NO EVENT SHALL FRANCK CHARLET OR CONTRIBUTORS BE LIABLE
   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
   OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
   SUCH DAMAGE.
   -------------------------------- */

#ifndef _MAIN_H_
#define _MAIN_H_

/* --------------------------------
   Includes
   -------------------------------- */
#include "support/startup.h"

/* --------------------------------
   Constants
   -------------------------------- */
#define SEQUENCE_SYS_CHECK 0
#define SEQUENCE_INTRO 1
#define SEQUENCE_MENU_MAIN 2
#define SEQUENCE_TOWN 3
#define SEQUENCE_RESTORE 4
#define SEQUENCE_WILDERNESS 5
#define SEQUENCE_DUNGEON 6
#define SEQUENCE_GRAVEYARD 7
#define SEQUENCE_SCROLL 8
#define SEQUENCE_END 9

#define SEQUENCE_START SEQUENCE_SYS_CHECK

#define LOGO_COLORS 100
#define MENUS_COLORS 15
#define TOWN_COLORS 16
#define PARTY_COLORS 64

#define MENU_MAIN_NEW_GAME 0
#define MENU_MAIN_RESTORE_GAME 1

#define TRACK_TITLE 2
#define TRACK_WILDERNESS 3
#define TRACK_COMBAT 4
#define TRACK_DUNGEON 5
#define TRACK_LOSE 6
#define TRACK_WIN 7

/* --------------------------------
   Variables
   -------------------------------- */
extern int Current_Sequence;
extern ULONG Current_Palette[256];
extern ULONG Menus_Palette[256];
extern ULONG Party_Palette[256];
extern ULONG Towns_Palette[256];
extern int Doing_Fade;
extern LPBITMAP Pic_Towns;
extern LPBITMAP Pic_Logo;
extern LPBITMAP Pic_Menus;
extern LPBITMAP Pic_Party;
extern LPFONT Font;
extern LPPOINTER Pointer;
extern BYTE *RawPic_Clouds;
extern ULONG *Ptr_Palette;

/* --------------------------------
   Functions
   -------------------------------- */
void Set_Fade(ULONG *Palette, int Speed, int PadMove);

#endif
