/* --------------------------------
   Phantasie II CD32
   Scrolls text
   --------------------------------
   Copyright (C) 2010-2016 Franck Charlet.
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:
   
       1. Redistributions of source code must retain the above copyright notice,
          this list of conditions and the following disclaimer.
       2. Redistributions in binary form must reproduce the above copyright notice,
          this list of conditions and the following disclaimer in the documentation
          and/or other materials provided with the distribution.

   THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS "AS IS" AND
   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED. IN NO EVENT SHALL FRANCK CHARLET OR CONTRIBUTORS BE LIABLE
   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
   OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
   SUCH DAMAGE.
   -------------------------------- */

/* --------------------------------
   Includes
   -------------------------------- */
#include "main.h"

/* --------------------------------
   Variables
   -------------------------------- */
char *Scroll0 =
    "YOU HEAR A BOOMING VOICE:\n"
    "\n"
    "\"MORTALS, I MUST CONGRATULATE YOU\n"
    "ON DEFEATING ME, PLUTO, IN MY MATERIAL\n"
    "FORM. I MUST ADMIT THAT I AM NOW POWER-\n"
    "LESS AGAINST YOU, BUT ALAS I AM LUCKILY\n"
    "IMMORTAL.  I WILL NOW TRAVEL BACK TO MY\n"
    "TRUE HOME, DEEP IN THE NETHERWORLD.\n"
    "THERE I WILL GENERATE A NEW MATERIAL\n"
    "FORM AND REGAIN MY MAGICAL POWERS.  I\n"
    "WILL BE BACK TO MY OLD FORM IN A MATTER\n"
    "OF DAYS.\"\n"
    "\n"
    "\"I TELL YOU ALL THIS SO THAT YOU WILL\n"
    "NOT GLOAT OVER YOUR VICTORY, AND SO\n"
    "THAT YOU WILL KNOW THAT WE MAY SOMEDAY\n"
    "MEET AGAIN IF I HAPPEN TO DECIDE THAT\n"
    "I WANT MY ITEMS BACK BEFORE YOUR TINY\n"
    "LIFESPANS HAVE EXPIRED. NEXT TIME I MAY\n"
    "NOT BE SO LOW IN POWER. AGAIN I FEEL\n"
    "I MUST CONGRATULATE YOU ON YOUR LUCK.\""
;

char *Scroll1 =
    "THE HISTORY OF FERRONRAH\n"
    "\n"
    "SEVERAL YEARS AGO THE EVIL WIZARD\n"
    "NIKADEMUS TOOK HIS TERRIBLE ARMY\n"
    "OF MEN AND BEASTS THROUGH THE SOUTH-\n"
    "ERN ISLANDS OF THE LAND INCLUDING\n"
    "GELNOR, FERRONRAH, AND THE LESSER\n"
    "ISLANDS.  IN A MATTER OF MONTHS\n"
    "HE HAD COMPLETELY OVERTAKEN THE\n"
    "CAPITAL.  NIKADEMUS ALSO HAD THE\n"
    "KING AND QUEEN AND THE REST OF THE\n"
    "ROYAL FAMILY EXECUTED.\n"
    "\n"
    "IN FERRONRAH HE COMPLETELY OBLIT-\n"
    "ERATED THE CAPITAL CITY LEAVING NOT\n"
    "A SINGLE BUILDING STANDING. THE CAP-\n"
    "ITAL HAS SINCE BEEN MOVED TO FERRON,\n"
    "A SMALL CITY TO THE NORTH OF THE OLD\n"
    "ISLANDS.\n"
    "\n"
    "BEFORE HE LEFT FERRONRAH, NIKADEMUS\n"
    "DECIDED TO MAKE SURE THAT\n"
    "NO ARMY WILL BE SENT AFTER HIM FROM\n"
    "FERRONRAH.\n"
    "\n"
    "HE CAST A TERRIBLE CURSE UPON THE\n"
    "ISLAND WHICH CAUSES ALL MORTALS\n"
    "ENTERING OR LEAVING FERRONRAH TO BE\n"
    "GREATLY REDUCED IN MENTAL AND\n"
    "PHYSICAL CAPABILITIES.\n"
    "\n"
    "THUS ANY NORMAL MAN SAILING TO\n"
    "OR FROM THE ISLAND IS RENDERED CLOSE\n"
    "TO THE POINT OF DEATH.  EVEN THE\n"
    "GREATEST OF WARRIORS WILL BECOME\n"
    "ORDINARY MEN.  NIKADEMUS THEREFORE\n"
    "CAN COLLECT TAXES FROM THE DENIZENS\n"
    "OF THE ISLAND AND FEEL SAFE THAT\n"
    "NONE OF THE DENIZENS OF THE ISLAND\n"
    "WOULD EVER TAKE VENGENCE ON HIM.\n"
    "\n"
    "NIKADEMUS CAST THE TERRIBLE\n"
    "CURSE WITH THE AID OF THE EVIL GOD\n"
    "PLUTO.  THE CURSE WAS PLACED IN\n"
    "AN ANCIENT ORB MADE OF VERY STRANGE\n"
    "MATERIAL NOT KNOWN TO MAN.  THE ORB\n"
    "WAS KEPT IN THE ROYAL PALACE OF\n"
    "FERRONRAH, BUT SEVERAL YEARS AGO\n"
    "LORD WOOD OF GELNOR LAUNCHED AN\n"
    "ASSAULT ON THE PALACE AND OBTAINED\n"
    "THE ORB.  LORD WOOD AND HIS BEST\n"
    "MEN WERE NOT ABLE TO DESTROY THE\n"
    "ORB WITH THEIR COMBINED MAGICAL\n"
    "POWERS.\n"
    "\n"
    "NIKADEMUS, UPON HEARING OF THE\n"
    "ASSAULT CAME BACK TO FERRONRAH WITH\n"
    "HIS ARMY AND RETRIEVED THE ORB, AND\n"
    "LORD WOOD BARELY ESCAPED WITH HIS\n"
    "LIFE.  THE ORB HAS SINCE BEEN MOVED\n"
    "TO AN UNKNOWN LOCATION.\n"
    "\n"
    "THE CURSE REMAINS ON FERRONRAH\n"
    "TO THIS DAY.  THE SITUAITON IS SEEM-\n"
    "INGLY HOPELESS, BUT IT IS RUMORED\n"
    "THAT A WISE OLD MAN WHO WANDERS THE\n"
    "ISLANDS IS TRYING TO DO SOMETHING."
;

char *Scroll2 =
    "THE KOBOLD VILLAGE\n"
    "\n"
    "IN THE NORTHERN PART OF\n"
    "FERRONRAH THERE IS A SMALL KOBOLD\n"
    "VILLAGE WHICH IS FORTIFIED BY A\n"
    "SMALL STONE WALL.  THE VILLAGE IS\n"
    "SITUATED ABOUT 60 MILES SOUTH OF\n"
    "PIPPACOTT ON THE SHORES OF PIPP-\n"
    "ACOTT BAY.\n"
    "\n"
    "THE KOBOLDS HAVE PRESENTED\n"
    "LITTLE TROUBLE TO THE SURROUNDING\n"
    "AREA THOUGH THEY HAVE OCCASIONALLY\n"
    "AMBUSHED UNWARY TRAVELERS.  IT\n"
    "IS RUMORED THAT SOMEWHERE IN THE\n"
    "VILLAGE THERE IS AN ANCIENT KOBOLD\n"
    "ORACLE WHICH GIVES STRANGE ADVICE\n"
    "TO THOSE WHO ARE WILLING TO SACRI-\n"
    "FICE FOR IT.  THE PRICE IS SAID TO\n"
    "BE HIGH FOR ADVICE OF LITTLE VALUE."
;

char *Scroll3 =
    "SENOG'S LABORATORY\n"
    "\n"
    "ABOUT FIVE HUNDRED YEARS\n"
    "AGO THERE LIVED ON FERRONRAH A\n"
    "GREAT AND POWERFUL WIZARD NAMED\n"
    "SENOG.  HIS LABORATORY WAS LO-\n"
    "CATED ON A SMALL ISLAND NEAR THE\n"
    "TOWN OF SAXLINGHAM.  IN HIS DAY\n"
    "HE WAS RESPECTED AND FEARED BY\n"
    "THE CITIZENS OF FERRONRAH.\n"
    "\n"
    "LEGEND HAS IT THAT SENOG\n"
    "ONCE CAPTURED AN IMP FROM THE\n"
    "NETHERWORLD.  THE IMP TAUGHT HIM\n"
    "THE SECRET OF TRAVELING TO THE\n"
    "NETHERWORLD.  SENOG OFTEN VISITED\n"
    "THE NETHERWORLD OR \"PLACE OF DE-\n"
    "PARTED SOULS\", IT WAS THERE THAT\n"
    "HE MET HIS DEMISE SOME YEARS LATER."
;

char *Scroll4 =
    "THE IMPLING HATCHERY\n"
    "\n"
    "DIRECTLY BELOW THE MATERIAL PLANE,\n"
    "WHERE ORDINARY MORTALS LIVE, LIES\n"
    "THE NETHERWORLD, OR \"THE PLACE OF\n"
    "DEPARTED SOULS\". UNLIKE THE MATERIAL\n"
    "PLANE, THE NETHERWORLD IS DIVIDED\n"
    "INTO MANY LEVELS.  THE FIRST LEVEL,\n"
    "WHICH IS CLOSEST TO THE MATERIAL\n"
    "PLANE, IS OCCUPIED BY IMPS.\n"
    "\n"
    "IT IS ON THIS LEVEL OF THE NETHER-\n"
    "WORLD THAT THE IMPLING HATCHERY CAN\n"
    "BE FOUND, FAR TO THE SOUTH OF BLACK\n"
    "MOOR.  IMPLINGS, WHICH ARE SIMPLY\n"
    "YOUNG IMPS, ARE RELATIVELY HELPLESS\n"
    "CREATURES.  THEY ARE, HOWEVER, WELL\n"
    "GUARDED BY TRAINED SNAKES AND HUMAN\n"
    "PRIESTS WHO HAVE BEEN BRAINWASHED\n"
    "BY THE IMPS."
;

char *Scroll5 =
    "FILMON THE SAGE\n"
    "\n"
    "IT IS RUMORED THAT THERE IS AN\n"
    "OLD BUT POWERFUL SAGE WHO ROAMS\n"
    "THESE ISLANDS.  HIS NAME IS\n"
    "FILMON.  IT IS SAID THAT FILMON\n"
    "IS STUDYING THE PROBLEM OF RECOV-\n"
    "ERING AND DESTROYING THE ORB.  HE\n"
    "WAS LAST SEEN SOUTH OF FERRON\n"
    "NEAR THE OLD CAPITAL CITY."
;

char *Scroll6 =
    "THE IMP CAVES\n"
    "\n"
    "ON THE FIRST LEVEL OF THE\n"
    "NETHERWORLD, TO THE NORTH OF\n"
    "DEATHPORT, LAY THE IMP CAVES.\n"
    "THE IMPS HAVE DEVISED A\n"
    "SECRET TRANSPORTATION METHOD FOR\n"
    "GETTING AROUND IN THE CAVES AND\n"
    "ONLY THEY KNOW HOW TO USE IT.\n"
    "SINCE THE IMPS ARE FORMIDABLE\n"
    "WITH HAND WEAPONS AND EXCELLENT\n"
    "SPELL CASTERS, VISITING THE CAVES\n"
    "COULD BE EXTREMELY HAZARDOUS."
;

char *Scroll7 =
    "THE SUMMER PALACE\n"
    "\n"
    "WHEN NIKADEMUS INVADED FERRON-\n"
    "RAH HE DESTROYED THE CAPITAL CITY,\n"
    "THE ROYAL PALACE, AND HAD THE\n"
    "ROYAL FAMILY EXECUTED.  THERE WAS,\n"
    "HOWEVER, A MUCH SMALLER PALACE WHERE\n"
    "THE ROYAL FAMILY USED TO SPEND THE\n"
    "SUMMERS.  IT WAS AT THIS SUMMER\n"
    "PALACE WHERE NIKADEMUS FIRST KEPT\n"
    "THE ORB.\n"
    "\n"
    "IT IS RUMORED THAT THE PRINCESS\n"
    "WAS NOT EXECUTED, AND IS BEING HELD\n"
    "IN THE SUMMER PALACE. SHE WAS IN THE\n"
    "PALACE WHEN LORD WOOD OCCUPIED IT,\n"
    "BUT DID NOT ESCAPE WHEN NIKADEMUS RE-\n"
    "TURNED.  IF THIS IS TRUE SHE MAY\n"
    "KNOW SOMETHING OF LORD WOOD'S\n"
    "EFFORTS TO DESTROY THE ORB.\n"
    "\n"
    "THE PALACE IS WEST OF LLITHFAEN."
;

char *Scroll8 =
    "PLUTO'S SMALLEST CASTLE\n"
    "\n"
    "ON THE SECOND LEVEL OF THE\n"
    "NETHERWORLD LIES THE SMALLEST\n"
    "CASTLE OF THE GREATEST OF THE\n"
    "EVIL GODS, PLUTO.  THOUGH THE\n"
    "CASTLE COVERS MANY SQUARE MILES\n"
    "AND IS ENORMOUS BY MORTALS STAN-\n"
    "DARDS, IT IS MERELY A RUNDOWN\n"
    "STONE SHACK TO ITS OWNER WHO\n"
    "VISITS ABOUT ONCE EVERY THOUSAND\n"
    "YEARS OR SO.\n"
    "\n"
    "THE CASTLE IS OCCUPIED BY\n"
    "DEMONS, DEVILS, SPIRITS AND\n"
    "THE LIKE.  IN FACT, ONLY THE UN-\n"
    "DEAD SERVANTS OF PLUTO ARE SAID\n"
    "TO BE ABLE TO GET IN.\n"
    "\n"
    "PLUTO'S MANY OTHER CASTLES\n"
    "ARE ALL SAID TO LIE IN THE DEEPER\n"
    "LEVELS OF THE NETHERWORLD."
;

char *Scroll9 =
    "PLUTO'S MENAGERIE\n"
    "\n"
    "ON THE SECOND LEVEL OF HADES\n"
    "IS LOCATED THE FAMOUS MENAGERIE\n"
    "OF THE EVIL GOD PLUTO.  IT IS\n"
    "SAID TO BE FULL OF SOME OF THE\n"
    "MOST TERRIBLE BEASTS IMAGINABLE\n"
    "INCLUDING PLUTO'S TWO MOST FAVOR-\n"
    "ITE BEASTS.  NO MORTAL HAS EVER\n"
    "VISITED THE MENAGERIE BECAUSE IT\n"
    "IS SURROUNDED BY LAVA FOR HUN-\n"
    "DREDS OF MILES ON ALL SIDES.\n"
    "\n"
    "THE BEST WAY TO GET THERE IS TO\n"
    "START AT DEMONIAC AND GO 210\n"
    "MILES SOUTH, 90 EAST, 50 SOUTH,\n"
    "60 WEST, 60 SOUTH, 100 WEST, 70\n"
    "NORTH, 70 WEST, 80 SOUTH, 70 WEST,\n"
    "AND 90 NORTH."
;

char *Scroll10 =
    "IMPS AND IMPLINGS\n"
    "\n"
    "IMPS ARE A VERY DEVIOUS AND\n"
    "VERY INTELLIGENT RACE OF HUMANOID\n"
    "CREATURES WHO OCCUPY THE FIRST\n"
    "LEVEL OF THE NETHERWORLD.  THEIR\n"
    "YOUNG ARE KNOWN AS IMPLINGS AND\n"
    "TEND TO BE LESS DEVIOUS THAN THE\n"
    "ADULTS.  UNLIKE MOST OTHER OCCU-\n"
    "PANTS OF THE NETHERWORLD IMPS ARE\n"
    "MORTAL CREATURES OF FLESH AND\n"
    "BLOOD.  THE IMPLINGS ARE HATCHED\n"
    "FROM EGGS.\n"
    "\n"
    "IT IS BELIEVED THAT THE IMPS\n"
    "ONCE RESIDED IN THE MATERIAL PLANE\n"
    "AND THEY WERE BANISHED INTO THE\n"
    "NETHERWORLD EONS AGO.  THERE THEY\n"
    "DEVELOPED THEIR GROTESQUE FORM.\n"
    "SHORTLY AFTER THEY WERE BAN-\n"
    "ISHED TO THE NETHERWORLD, THE IMPS\n"
    "DISCOVERED THE SECRET OF TRAVEL-\n"
    "LING BETWEEN THE PLANES.  THEY\n"
    "BEGAN TO MAKE FREQUENT RAIDS ON\n"
    "THE MATERAIL PLANE, KNOWING THAT\n"
    "FEW OF ITS CITIZENS COULD FOLLOW\n"
    "THEM BACK TO THE NETHERWORLD.\n"
    "\n"
    "THE IMPS HAVE LEARNED TO USE\n"
    "THE POWERS OF BLACK MAGIC AND HAVE\n"
    "PERFECTED VARIOUS BRAINWASHING\n"
    "TECHNIQUES."
;

char *Scroll11 =
    "THE BOOK OF BEASTS\n"
    "\n"
    "MANY EONS AGO WHEN PLUTO FIRST\n"
    "BECAME THE RULER OF THE NETHERWORLD\n"
    "HE CREATED NINE UNIQUE BEASTS.  HE\n"
    "USED SOME OF HIS OWN BLOOD TO CREATE\n"
    "THE BEASTS AND THUS EACH BEAST IS\n"
    "IMMORTAL AND POSESSES MAGIC AS\n"
    "GREAT AS PLUTO DOES.  PLUTO ALSO\n"
    "GAVE EACH BEAST A VERY SPECIAL AMULET\n"
    "TO HELP PROTECT IT AGAINST ALL TYPES\n"
    "OF ATTACK.\n"
    "\n"
    "PLUTO THEN PLACED MOST OF THE\n"
    "BEASTS IN VARIOUS DIFFERENT PLANES\n"
    "AND LET THEM ROAM ABOUT.  EACH BEAST\n"
    "COMES TO VISIT PLUTO EVERY FEW YEARS.\n"
    "THE MAIN PURPOSE OF THE BEASTS IS TO\n"
    "DEMONSTRATE PLUTO'S GREAT POWER.\n"
    "\n"
    "BEAST I IS THE GIANT CONSTRICTOR,\n"
    "AN ENOURMOUS GREEN SNAKE, AND BEAST\n"
    "II IS THE WINGED DEVIL, A SMALL RED\n"
    "IMPISH CHARACTER WITH LARGE WINGS.\n"
    "THESE BEASTS CAN BE FOUND IN ANY OF\n"
    "THEY PLANES AT ANY TIME AND PLACE.\n"
    "BEAST III IS THE TERRIFYING UNDEAD\n"
    "SNAKE WHICH IS BLUE IN COLOR, AND\n"
    "BEAST IV IS THE HORRIBLE DEMON-FLY\n"
    "A SMALL BLUE BEAST SIMILAR TO THE\n"
    "WINGED DEVIL.  THESE TWO BEASTS\n"
    "STICK TO THE MATERIAL PLANE AND STAY\n"
    "MAINLY ON SMALL DESERT ISLANDS.\n"
    "BEAST V IS THE MYSTERIOUS WYVERN,\n"
    "A SMALL RED DRAGON-LIKE CREATURE, AND\n"
    "BEAST VI IS THE GREEN SNAKE-DRAGON\n"
    "WHICH CAN ASSUME THE SHAPE OF A DRA-\n"
    "GON OR A SNAKE.  THESE TWO ROAM THE\n"
    "ASTRAL PLANE AND CAN BE SUMMONED BY\n"
    "A POWERFUL MAGIC SPELL.\n"
    "\n"    
    "BEAST VII IS THE GIANT WYVERN\n"
    "WHICH IS A LARGE RED DRAGON-LIKE\n"
    "CREATURE, AND BEAST VIII IS THE\n"
    "DREADED DRAGON-DEMON A HIDEOUS WHITE\n"
    "CREATURE WHICH CAN ASSUME THE SHAPE\n"
    "OF A DRAGON OR A DEMON.  PLUTO KEEPS\n"
    "THESE TWO BEASTS AS PETS SOMEWHERE\n"
    "SOMEWHERE IN THE NETHERWORLD ALSO.\n"
    "BEAST IX, THE ICE DRAGON, IS\n"
    "PERHAPS THE MOST SPECTACTULAR ANIMAL\n"
    "ALIVE.  NO MORTAL CAN POSSIBLY AP-\n"
    "PROACH IT.  IF FACT, ONLY PLUTO AND\n"
    "THE OTHER BEASTS HAVE EVER SEEN IT.\n"
    "IT IS BELIEVED THAT PLUTO KEEPS IT\n"
    "IN THE NETHERWORLD."
;

char *Scroll12 =
    "SENOG'S TRAVELS\n"
    "\n"
    "MANY YEARS AGO THE GREAT WIZ-\n"
    "ARD SENOG TRICKED AN IMP INTO\n"
    "TELLING HIM THE SECRET OF TRAVEL-\n"
    "LING INTO THE NETHERWORLD.  FOR\n"
    "OVER TWELVE YEARS SENOG WANDERED\n"
    "THROUGH THE NETHERWORLD UNTIL HE\n"
    "BECAME OBSESSED WITH IT.\n"
    "\n"
    "IN HIS TRAVELS, SENOG VISITED\n"
    "MANY STRANGE AND MYSTERIOUS\n"
    "PLACES, INCLUDING THE IMPLING\n"
    "HATCHERY AND THE FORGOTTEN TEMPLE.\n"
    "HE USED HIS POWERFUL MAGIC TO\n"
    "KEEP HIM ALIVE.  HIS MOST DARING\n"
    "ADVENTURE WAS WHEN HE EXPLORED\n"
    "PLUTO'S CASTLE ON THE SECOND LEVEL\n"
    "OF THE NETHERWORLD.  HE ENTERED,\n"
    "THROUGH THE MIDDLE DOOR ON THE\n"
    "WEST SIDE AND SNUCK PAST THE\n"
    "GUARD, BUT HE NEVER RETURNED."
;

char *Scroll13 =
    "DEPARTED SOULS\n"
    "\n"
    "WHENEVER A MORTAL FROM THE MATER-\n"
    "IAL PLANE DIES, HIS SOUL BEGINS THE\n"
    "JOURNEY TO THE ASTRAL PLANE FOR\n"
    "JUDGEMENT.  THE JOURNEY CAN TAKE\n"
    "YEARS AND A RESURRECTION SPELL CAST\n"
    "DURING THIS TIME MAY RECALL THE SOUL\n"
    "TO THE BODY.  IF THE SOUL ARRIVES\n"
    "AT THE ASTRAL PLANE IT WILL BE\n"
    "JUDGED, AND IF DEEMED UNWORTHY OF\n"
    "EXISTANCE, IT WILL BE DESTROYED.\n"
    "THE SOUL MAY BE JUDGED AS PREMATURE\n"
    "AND BE RETURNED TO ITS RESURRECTED\n"
    "BODY.  IT THE SOUL BELONGED TO AN\n"
    "OUTSTANDING BEING IT MAY BE ACCEPTED\n"
    "INTO THE HEAVENS IF GOOD, OR DEEP\n"
    "INTO THE NETHERWORLD IF EVIL.\n"
    "\n"
    "THOSE SOULS THAT ARE LEFT ARE\n"
    "RETURNED TO THEIR BODIES AS 'UNDEAD'\n"
    "AND LEFT TO ROAM THE MATERIAL PLANE\n"
    "OR LOWER LEVELS OF THE NETHERWORLD."
;

char *Scroll14 =
    "THE FORGOTTEN TEMPLE\n"
    "THERE IS A VERY ANCIENT TEMPLE ON\n"
    "THE SECOND LEVEL OF THE NETHERWORLD\n"
    "WHOSE PURPOSE HAS LONG BEEN FORGOT-\n"
    "TEN. THE TEMPLE IS SURROUNDED BY\n"
    "LAVA AND, THEREFORE, NOT EASY TO\n"
    "WALK TO.\n"
    "\n"
    "THE BEST WAY TO GET TO THE TEMPLE\n"
    "IS VIA THE ASTRAL PLANE.  THE ASTRAL\n"
    "PLANE IS A STRANGE LIGHT-FILLED VOID\n"
    "WHICH INTERCONNECTS ALL THE OTHER\n"
    "PLANES.\n"
    "\n"
    "THERE IS A VORTEX IN THE WATER\n"
    "WEST OF THE IMPLING HATCHERY WHICH\n"
    "LEADS FROM THE FIRST LEVEL OF THE\n"
    "NETHERWORLD TO THE ASTRAL PLANE.\n"
    "A SIMILAR VORTEX LEADS FROM THE\n"
    "ASTRAL PLANE TO THE SECOND LEVEL OF\n"
    "THE NETHERWORLD, NOT FAR FROM THE\n"
    "TEMPLE."
;

char **Scrolls[] =
{
    &Scroll1,
    &Scroll2,
    &Scroll3,
    &Scroll4,
    &Scroll5,
    &Scroll6,
    &Scroll7,
    &Scroll8,
    &Scroll9,
    &Scroll10,
    &Scroll11,
    &Scroll12,
    &Scroll13,
    &Scroll14,

    /* Last pluto's message */
    &Scroll0
};

extern LPBITMAP BitMap_Ptr_Front;
extern LPBITMAP BitMap_Ptr_Back;
int Old_Sequence;
int Page_Lines_Scroll;
int Lines_Scroll;
char *Scroll_Text;
int Cur_Scroll_Page;
int Nbr_Scroll_Pages;
int Exit_Scroll;
char *Scroll_Pages[32];
int Scroll_Y[32];

/* --------------------------------
   Create a scroll context
   -------------------------------- */
void Display_Scroll(int Idx)
{
    int i;
    int Cur_Line;

    Old_Sequence = Current_Sequence;
    Current_Sequence = SEQUENCE_SCROLL;
    Scroll_Text = *Scrolls[Idx];

    if(Scroll_Text == Scroll0)
    {
        Current_Palette[237] = 0x7a0500;
        Current_Palette[238] = 0xc51000;
    }

    Page_Lines_Scroll = (SCREEN_HEIGHT / (Font->Height + 1)) - 1;
    Nbr_Scroll_Pages = 0;

    Cur_Scroll_Page = 0;
    Exit_Scroll = FALSE;

    Scroll_Pages[Nbr_Scroll_Pages] = Scroll_Text;
    Nbr_Scroll_Pages++;

    /* Fill the table of pages pointers */
    while(1)
    {
        Cur_Line = 0;
        i = 0;
        while(Cur_Line < Page_Lines_Scroll)
        {
            i = 0;
            while(Scroll_Text[i] != '\n' && Scroll_Text[i])
            {
                i++;
            }
            if(!Scroll_Text[i]) break;
            i++;
            Cur_Line++;
            Scroll_Text += i;
        }
        if(!Scroll_Text[i]) break;
        Scroll_Y[Nbr_Scroll_Pages - 1] = (SCREEN_HEIGHT - (Cur_Line * (Font->Height + 1))) / 2;
        Scroll_Pages[Nbr_Scroll_Pages] = Scroll_Text;
        Nbr_Scroll_Pages++;
    }
    Scroll_Y[Nbr_Scroll_Pages - 1] = (SCREEN_HEIGHT - (Cur_Line * (Font->Height + 1))) / 2;

    Set_Fade(Black_Palette, 20, MOVE_NONE);
}

/* --------------------------------
   Run in a scroll context
   -------------------------------- */
void Loop_Scroll(ULONG Pad_Dats)
{
    int i;
    char Car;
    int Pos_X = 0;
    int Pos_Y = 0;
    int Cur_Line;
    int Chars;

    Pad_Dats = Pad_Dats & ~PAD_SPEED;

    switch(Pad_Dats)
    {
        case PAD_LEFT:

            if(Cur_Scroll_Page > 0)
            {
                Cur_Scroll_Page--;
                Set_Fade(Black_Palette, 20, MOVE_NONE);
            }
            break;

        case PAD_RIGHT:

            if(Cur_Scroll_Page < Nbr_Scroll_Pages - 1)
            {
                Cur_Scroll_Page++;
                Set_Fade(Black_Palette, 20, MOVE_NONE);
            }
            break;

        case PAD_OK:
        case PAD_CANCEL:

            /* May have been modified by last scroll */
            Current_Palette[237] = 0x706a60;
            Current_Palette[238] = 0xc5c0ba;

            Exit_Scroll = TRUE;
            Set_Fade(Black_Palette, 20, MOVE_NONE);
            break;
    }

    if(!Doing_Fade && Ptr_Palette == Black_Palette)
    {
        if(Exit_Scroll)
        {
            Clear_Screen(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
            Current_Sequence = Old_Sequence;
        }
        else
        {
            Clear_Array(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
    
            Scroll_Text = Scroll_Pages[Cur_Scroll_Page];
            Pos_Y = Scroll_Y[Cur_Scroll_Page];

            Cur_Line = 0;
            while(Cur_Line < Page_Lines_Scroll)
            {
                i = 0;
                Chars = 0;
                while(Scroll_Text[i] != '\n' && Scroll_Text[i])
                {
                    Chars += Font->Width;
                    i++;
                }
            
                Pos_X = (SCREEN_WIDTH - Chars) / 2;
            
                i = 0;
                while(Scroll_Text[i] != '\n' && Scroll_Text[i])
                {
                    Car = Scroll_Text[i] - 0x20;
                    Copy_To_Screen(Font->Bank,
                                   (Car * Font->Width),
                                   Font->Height,
                                   Pos_X,
                                   Pos_Y,
                                   Font->Width,
                                   Font->Height);
            
                    Pos_X += Font->Width;
                    i++;
                }
                if(!Scroll_Text[i]) break;
                i++;
                Pos_Y += (Font->Height + 1);
                Cur_Line++;
                Scroll_Text += i;
            }
    
            if(Cur_Scroll_Page)
            {
                Copy_To_Screen(Font->Bank,
                               (('<' - 0x20) * Font->Width),
                               Font->Height,
                               0,
                               SCREEN_HEIGHT - (Font->Height + 1),
                               Font->Width,
                               Font->Height);
            }
    
            if(Cur_Scroll_Page < Nbr_Scroll_Pages - 1)
            {
                Copy_To_Screen(Font->Bank,
                               (('>' - 0x20) * Font->Width),
                               Font->Height,
                               SCREEN_WIDTH - Font->Width,
                               SCREEN_HEIGHT - (Font->Height + 1),
                               Font->Width,
                               Font->Height);
            }
    
            /* Copy the whole screen on the back buffer */
            Swap_Physical_Buffers();
            Clear_Array(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);    
    
            Copy_To_Bitmap(BitMap_Ptr_Back,
                           0,
                           0,
                           BitMap_Ptr_Front,
                           0,
                           0,
                           SCREEN_WIDTH,
                           SCREEN_HEIGHT,
                           ABC | ABNC
                          );
    
            Set_Fade(Current_Palette, 20, MOVE_HORIZONTALLY);
        }
    }
}
