/* --------------------------------
   Phantasie II CD32
   Pad controller handling
   --------------------------------
   Copyright (C) 2010-2016 Franck Charlet.
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:

       1. Redistributions of source code must retain the above copyright notice,
          this list of conditions and the following disclaimer.
       2. Redistributions in binary form must reproduce the above copyright notice,
          this list of conditions and the following disclaimer in the documentation
          and/or other materials provided with the distribution.

   THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS "AS IS" AND
   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED. IN NO EVENT SHALL FRANCK CHARLET OR CONTRIBUTORS BE LIABLE
   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
   OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
   SUCH DAMAGE.
   -------------------------------- */

#ifndef _PAD_H_
#define _PAD_H_

/* --------------------------------
   Constants
   -------------------------------- */
#define PAD_BUTTON_BLUE 0x800000
#define PAD_BUTTON_RED 0x400000
#define PAD_BUTTON_YELLOW 0x200000
#define PAD_BUTTON_GREEN 0x100000

#define PAD_BUTTON_FORWARD 0x80000
#define PAD_BUTTON_REVERSE 0x40000
#define PAD_BUTTON_PLAY 0x20000

#define PAD_BUTTON_UP 8
#define PAD_BUTTON_DOWN 4
#define PAD_BUTTON_LEFT 2
#define PAD_BUTTON_RIGHT 1

#define PAD_NOP 0
#define PAD_OK 1
#define PAD_CANCEL 4
#define PAD_SPEED 8
#define PAD_LEFT 16
#define PAD_RIGHT 32
#define PAD_PANIC 64
#define PAD_PREVIOUS 128
#define PAD_NEXT 256

#define MOVE_NONE 0
#define MOVE_HORIZONTALLY 1
#define MOVE_VERTICALLY 2

/* --------------------------------
   Functions
   -------------------------------- */
ULONG Check_Pad_Arrow(ULONG Joypad_Dats, ULONG Button, int Idx, BYTE Throttle_Slow, BYTE Throttle_Fast);
ULONG Get_Pad(BYTE Throttle_Slow, BYTE Throttle_Fast);
void Wait_Pad_Ok();
void Wait_Pad_Ok_Cancel();
void Set_Pad_Move(int Pad_Move);

#endif
