# Some routines in asm
#
# Copyright (C) 2010-2016 Franck Charlet.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#     1. Redistributions of source code must retain the above copyright notice,
#        this list of conditions and the following disclaimer.
#     2. Redistributions in binary form must reproduce the above copyright notice,
#        this list of conditions and the following disclaimer in the documentation
#        and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL FRANCK CHARLET OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

                .global _Handler_Stub
                .global _Input_Handler
                .global _RLEDepack
                .global _PadRead

# Pass the argument to the C events handler
_Handler_Stub:  movem.l a0/a1,-(a7)
                jsr     _Input_Handler
                addq.l  #8,a7
                rts

# RLE depacker
# size/source/dest
_RLEDepack:     movem.l d1/d2/a0/a1,-(a7)
                movem.l 4+(4*4)(a7),d0/a0/a1
Decrunch:       moveq   #0,d2
                move.b  (a0)+,d2
                bmi.b   Pixels
CopyPixs:       move.b  (a0)+,(a1)+
                subq.l  #1,d0
                dble    d2,CopyPixs
                bra.b   NoPixel
Pixels:         neg.b   d2
                move.b  (a0)+,d1
CopyRepeat:     move.b  d1,(a1)+
                subq.l  #1,d0
                dble    d2,CopyRepeat
NoPixel:        tst.l   d0
                bgt.b   Decrunch
                movem.l (a7)+,d1/d2/a0/a1
                rts

# Read the state of the joystick/pad
# In:
# Port number
#
# Out:
# d0: Pad data
CIAB_GAMEPORT0 = 6
CIAB_GAMEPORT1 = 7
_PadRead:       move.l  4(a7),d0
                movem.l d1/d2/d3/d4/d5/d6/d7/a1/a2,-(a7)
                lea     0xbfe001,a1
                lea     0xdff000,a2
                moveq   #CIAB_GAMEPORT0,d3
                moveq   #10,d4
                move.w  #0xf600,d5
                moveq   #0xA,d6
                tst.w   d0
                beq.b   .direction
                moveq   #CIAB_GAMEPORT1,d3
                moveq   #14,d4
                move.w  #0x6f00,d5
                moveq   #0xC,d6
.direction:     moveq   #0,d7
                move.w  (a2,d6.w),d0
                move.w  d0,d1
                lsr.w   #1,d1
                eor.w   d0,d1
                btst    #8,d1
                sne     d7
                add.w   d7,d7
                btst    #0,d1
                sne     d7
                add.w   d7,d7
                btst    #9,d0
                sne     d7
                add.w   d7,d7
                btst    #1,d0
                sne     d7
                add.w   d7,d7
                swap    d7
                btst    d4,0xdff016
                seq     d7
                add.w   d7,d7
                btst    d3,(a1)
                seq     d7
                add.w   d7,d7
                and.w   #0x300,d7
                asr.l   #2,d7
                swap    d7
                asr.w   #6,d7
                bset    d3,0x200(a1)
                bclr    d3,(a1)
                move.w  d5,0xdff034
                moveq   #0,d0
                moveq   #8-1,d1
                bra.b   in
loop:           tst.b   (a1)
                tst.b   (a1)
in:             tst.b   (a1)
                tst.b   (a1)
                tst.b   (a1)
                tst.b   (a1)
                tst.b   (a1)
                tst.b   (a1)
                move.w  0xdff016,d2
                bset    d3,(a1)
                bclr    d3,(a1)
                btst    d4,d2
                bne.b   next
                bset    d1,d0
next:           dbf     d1,loop
                bclr    d3,0x200(a1)
                swap    d0
                or.l    d7,d0
                move.w  #-1,0xdff034
                movem.l (a7)+,d1/d2/d3/d4/d5/d6/d7/a1/a2
                rts

                .end
