/* --------------------------------
   Phantasie II CD32
   Towns handling
   --------------------------------
   Copyright (C) 2010-2016 Franck Charlet.
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:

       1. Redistributions of source code must retain the above copyright notice,
          this list of conditions and the following disclaimer.
       2. Redistributions in binary form must reproduce the above copyright notice,
          this list of conditions and the following disclaimer in the documentation
          and/or other materials provided with the distribution.

   THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS "AS IS" AND
   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED. IN NO EVENT SHALL FRANCK CHARLET OR CONTRIBUTORS BE LIABLE
   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
   OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
   SUCH DAMAGE.
   -------------------------------- */

#ifndef _TOWNS_H_
#define _TOWNS_H_

/* --------------------------------
   Includes
   -------------------------------- */
#include "support/startup.h"
#include "characters.h"

/* --------------------------------
   Constants
   -------------------------------- */
#define MAX_TOWNS 10

enum TOWN
{
    NOWHERE = 0,
    PIPPACOTT,
    HASLEMERE,
    SAXLINGHAM,
    LLITHFAEN,
    IPSWICH,
    FERRON,
    BLACK_MOOR,
    DEATHPORT,
    DEMONIAC,
    DARK_ABYSS
};

/* --------------------------------
   Structures
   -------------------------------- */
typedef struct __attribute__((packed))
{
    BYTE Stock[MAX_ITEMS];
    BYTE Stock_Modifiers[16];
    WORD Multiplier;
    char Name[20];
    BOOL Loaded;
} TOWNDAT, *LPTOWNDAT;

/* --------------------------------
   Variables
   -------------------------------- */
extern TOWNDAT Towns[MAX_TOWNS];
extern LPMENU Menu_Town_Main;
extern int Cur_Town_Nbr;
extern LPTOWNDAT Cur_Town;
extern float Prices_Multiplier;

/* --------------------------------
   Functions
   -------------------------------- */
BOOL Init_Town(int Town);
void Loop_Town(ULONG Joypad_Dats);
void Destroy_Town();
int Load_Towns(void);
void Set_Town_Pic(BOOL Clear);
void Fade_Town_Pic();
void Construct_Main_Town_Menu();
void Set_Current_Town(int Town_Nbr);
void Fix_Current_Town(void);

#endif
